#include "incl.h"

int CIPL_Negative(THEADER *, THEADER *);

int CIPL_Negative(THEADER *it, THEADER *ot)
{
     int i, j, max;

     do {
	  max = HIPL_Getpart(it);
	  if (max < 0) {
	       HIPL_Error("Error in Getpart - incomplete read");
	       return(max);
	  }

	  for (i=0; i<max; i++) {
	       for (j=0; j<it->img.COLS; j++) {
		    ot->iarr[i][j] = 255 - it->iarr[i][j];
		    ot->jarr[i][j] = 255 - it->jarr[i][j];
		    ot->karr[i][j] = 255 - it->karr[i][j];
	       }
	  }

	  max = HIPL_Putpart(ot);
	  if (max < 0) {
	       HIPL_Error("Error in Putpart - incomplete write");
	       return(max);
	  }

	  if (ot->P.nleft == 0)
	       max = -1;
     } while (max >= 0);

     HIPL_Refresh(it, 0);
     HIPL_Refresh(ot, 0);

     return(0);
}

