#include "incl.h"

typedef struct node {
	int label;
	struct node *next;
	}*NODEPTR;
typedef struct heads{
	int gray;
	struct node *rptr;
	struct heads *nptr;
	}*HEADPTR;
// HEADPTR head = NULL;

int addlabel(HEADPTR *ptr,int label)
{
	HEADPTR ptr1;
	if(*ptr == NULL){
		*ptr = (HEADPTR)malloc(sizeof(struct heads));
		ptr1 = *ptr;
		}
	else {
		ptr1 = *ptr;
		while(ptr1->nptr != NULL) ptr1 = ptr1->nptr;
		ptr1->nptr = (HEADPTR)malloc(sizeof(struct heads));
		ptr1 = ptr1->nptr;
		}
	ptr1->nptr = NULL;
	ptr1->gray = 0;
	ptr1->rptr = (NODEPTR)malloc(sizeof(struct node));
	ptr1->rptr->label = label;
	ptr1->rptr->next = NULL;
	return 0;
}
int combine(HEADPTR ptr,int label1,int label2)
{
	int flag = 1,search;
	HEADPTR save1,save,savehead;
	if(ptr == NULL) return -1;
	save = ptr;
	savehead = ptr;
	while(flag) {
	if(found(ptr,label1))
	{
		save = ptr;
		save1 = save->nptr;
		search = label2;
		if(found(ptr,label2))
			return 0;	
		else
			flag = 0;
	}
	else
	if(found(ptr,label2))
	{
		save = ptr;
		save1 = save->nptr;
		search = label1;
		if(found(ptr,label1))
			return 0;	
		else
			flag = 0;
	}
	else
	{
	ptr = ptr->nptr;
	if(ptr == NULL) return -1;
	}
	}

	flag = 1;
	while(flag) {
	if(save1 == NULL) return -1;
	if(found(save1,search))
	flag = 0;
	else
	save1 = save1->nptr;
	}
	append(savehead,save,save1);
}
int append(HEADPTR ptr,HEADPTR save,HEADPTR save1)
{
	NODEPTR ptr1;
	ptr1 = save->rptr;
	while(ptr1->next != NULL)
		ptr1 = ptr1->next;
	ptr1->next = save1->rptr;
	save1->rptr = NULL;
	while(ptr->nptr!=save1)
	ptr = ptr->nptr;
	ptr->nptr = save1->nptr;
	save1->nptr = NULL;
	free(save1);
	return 0;
}
int deleteall(HEADPTR *ptr)
{
	HEADPTR ptr1,ptr11;
	NODEPTR ptr2,ptr22;
	if(*ptr == NULL) return 0;
	ptr1 = *ptr;
	while(ptr1 != NULL) {
	ptr11 =ptr1->nptr;
	ptr2 = ptr1->rptr;
	ptr22 = ptr2;
		while(ptr22 != NULL) {
			ptr2 = ptr22->next;
			ptr22->next = NULL;
			free(ptr22);
			ptr22 = ptr2;
			}
	ptr1->rptr = NULL;
	ptr1->nptr = NULL;
	free(ptr1);
	ptr1 = ptr11;
	}
	return 0;
}
int found(HEADPTR ptr,int label)
{
	NODEPTR ptr1;
	if(ptr==NULL)
		return 0;
	ptr1 = ptr->rptr;
	if(ptr1==NULL)
		return 0;
	while(ptr1!=NULL) {
		if(ptr1->label == label)
			return 1;
		else ptr1 = ptr1->next;
		}
	return 0;
}
int assigngray(HEADPTR ptr)
{
	int count,increment,gray;
	/* count = findcount(ptr);                 These lines are commented
	   increment = 255/count;                  out by Chak Bhagvati on
	   if(count > 255)                         07 March 2001 */
	increment = 1;
	gray = increment;
	while(ptr != NULL)
	{
	ptr->gray=gray;
	gray += increment;
	/* if(gray == 256) gray = 1; */
	ptr = ptr->nptr;
	}	
	return 0;
}
int findcount(HEADPTR ptr)
{
	int count=0;
	while(ptr != NULL)
	{
	count++;
	ptr = ptr->nptr;
	}
	return(count);
}
int findgray(HEADPTR ptr,int label) 
{
	while(ptr != NULL) {
	if(found(ptr,label))
	return ptr->gray;
	ptr = ptr->nptr;
	}
	return -1;
}

int HIPL_Connect(THEADER *it,THEADER *ot)
{
	int i,j,max,label[4],c=0,k;
	THEADER *temp;
	int unique=1;
	DATA *ID;
	HEADPTR head = NULL;
	int numcomp;
	temp=(THEADER *)malloc(sizeof(THEADER));
	ID=(DATA *)malloc(sizeof(DATA));
	ID->ROWS=it->img.ROWS;
	ID->COLS=it->img.COLS;
	ID->ver=it->ver;

	i=HIPL_Initialise(temp,NULL,1,0,ID);
	i=HIPL_AllocateMem(temp);

	it->MROWS=temp->MROWS=2;
	it->MCOLS=temp->MCOLS=1;
	it->MORGX=temp->MORGX=1;
	it->MORGY=temp->MORGY=0;
	for(j=0;j<temp->img.COLS;j++)
		temp->iarr[0][j]=0;
		
	do {
		max = HIPL_Getpart(it);
		for(i=0;i<max;i++)
			{
			for(j=0;j<it->img.COLS;j++)
				{
				if(c+i==0)
				{
				label[0]=0;
				label[1]=0;
				label[2]=0;
				if(j==0)
				label[3]=0;
				else
				label[3]=temp->iarr[i][j-1];
				}
				else
				if(j==0)
				{
				label[0]=0;
				label[3]=0;
				label[1]=temp->iarr[i-1][j];
				label[2]=temp->iarr[i-1][j+1];
				}
				else
				if(j==(it->img.COLS-1))
				{
				label[2]=0;
				label[0]=temp->iarr[i-1][j-1];
				label[1]=temp->iarr[i-1][j];
				label[3]=temp->iarr[i][j-1];
				}
				else
				{
				label[0]=temp->iarr[i-1][j-1];
				label[1]=temp->iarr[i-1][j];
				label[3]=temp->iarr[i][j-1];
				label[2]=temp->iarr[i-1][j+1];
				}	
				if(it->iarr[i][j]==255)
				{
				for(k=0;k<4;k++)
					if(label[k]!=0) 
					{
					temp->iarr[i][j]=label[k];
					break;
					}
				if(k==4) 
				{
				temp->iarr[i][j]=unique;
				addlabel(&head,unique);
				unique++;
				}
				switch(k){
				case 0:
				if((label[1]!=0)&&(label[0]!=label[1]))
					combine(head,label[0],label[1]);	
				if((label[2]!=0)&&(label[0]!=label[2]))
					combine(head,label[0],label[2]);	
				if((label[3]!=0)&&(label[0]!=label[3]))
					combine(head,label[0],label[3]);
				break;
	
				case 1:
				if((label[2]!=0)&&(label[1]!=label[2]))
					combine(head,label[1],label[2]);	
				if((label[3]!=0)&&(label[1]!=label[3]))
					combine(head,label[1],label[3]);
				break;
	
				case 2:
				if((label[3]!=0)&&(label[2]!=label[3]))
					combine(head,label[2],label[3]);
				break;
				
				default:
				break;
				}
				}
				else 
				{
				temp->iarr[i][j] = 0;
				}	
			}

		}
		c+=max;
		i = HIPL_Putpart(temp);
	}while(temp->P.nleft);
	HIPL_Refresh(temp,0);
	HIPL_Refresh(it,0);
	ot->MROWS = temp->MROWS = 0;
	ot->MORGX = temp->MORGX = 0;
	ot->MCOLS = temp->MCOLS = 0;
	ot->MORGY = temp->MORGY = 0;
	assigngray(head);
	do{
		max = HIPL_Getpart(temp);

		for(i=0;i<max;i++)
			for(j=0;j<temp->img.COLS;j++){
				if(temp->iarr[i][j]==0)
				ot->iarr[i][j]=0;
				else
				ot->iarr[i][j] = findgray(head,temp->iarr[i][j]);
				}
		max = HIPL_Putpart(ot);
	}while(ot->P.nleft);
numcomp=findcount(head); /* Line added by Chak Bhagvati on 07/03/2001 */
deleteall(&head);
HIPL_Closeall(temp);
HIPL_FreeMem(temp);
free(temp);
free(ID);
return(numcomp);
}
	

	
