global projecttcl123
global maximu
set projecttcl123 0
set i 1
set current .t1

set j [catch {glob HIPL_*.pgm} files]
if { $j == 0 } {
	puts "Remove HIPL_*.pgm files to use the IP Tool Kit"
	puts "Be careful in removing files : if an IP Tool Kit is already running in this directory then it may not operate further"
	exit.old 1
}
set j [catch {glob CIPL_*.ppm} files]
if { $j == 0 } {
	puts "Remove CIPL_*.ppm files to use the IP Tool Kit"
	puts "Be careful in removing files : if an IP Tool Kit is already running in this directory then it may not operate further"
	exit.old 1
}
set j [catch {glob hipl*.idt} files]
if { $j == 0 } {
	puts "Remove hipl_*.idt files to use the IP Tool Kit"
	puts "Be careful in removing files : if an IP Tool Kit is already running in this directory then it may not operate further"
	exit.old 1
}
set j [catch {glob IPL_Cnv*.pgm} files]
if { $j == 0 } {
	puts "Remove IPL_*.pgm files to use the IP Tool Kit"
	puts "Be careful in removing files : if an IP Tool Kit is already running in this directory then it may not operate further"
	exit.old 1
}
set fileid [open hipl_.idt w+]
close $fileid

proc exit {} {
	set j [catch {glob HIPL_*.pgm} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	set j [catch {glob CIPL_*.ppm} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	set j [catch {glob IPL_Cnv*.pgm} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	set j [catch {glob hipl*.idt} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	exit.old 0
}
proc topopen {fname} {
	global obj suri current _current _current1 _tx _ty _bx _by _px _py projecttcl123 _arr
	set _arr 0
	set i1 [unique next]
	set i $i1
	set obj(.t$i1) [pimage $fname]
	set objname [set obj(.t$i1)]
	set j [$objname ver]
	
	if { $j == 0 } { set fn1 $fname }
	if { $j == 1 } { set fn1 [$objname convert] }
	toplevel .t$i1 -background lightgray -class Imgobj
	#option add *Imgobj*font {times 10 bold normal} startupFile
	#option add *Imgobj*anchor nw startupFile
	
	set fid [ open $fname r ]
	global _typ$i1 _model$i1
	set _model$i1 "RGB"
	set _typ$i1 [ read $fid 2 ]
	close $fid
	
	bind .t$i1  <Motion> {
		global current 
		set current %W
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
	}
	bind .t$i1  <Double-1> {
		global _current _current1
		set _current %W
		set r [string first .f $_current]
		incr r -1
		set _current [string range $_current 0 $r]
		set _current1 [wm title $_current] 
		gettype $_current1
	}
	wm geometry .t$i1 =810x500+0+115
	wm title .t$i1 $fname
	wm resizable .t$i1 0 0
	wm iconname .t$i1 $fname
	if { $projecttcl123 == 9999 } {
		wm protocol .t$i1 WM_DELETE_WINDOW "rm1 .t$i1"
	}
	proc rm1 opr {
		global obj _current1 _current
		set f1 [wm title $opr]
		set f3 [file tail $f1]
		if { [string match "HIPL_*" $f3] } {
			savecall $f1
		} 
		if { [string match "CIPL_*" $f3] } {
			savecall $f1
		} 
		if { $_current1 == $f1 } {
			set _current1 ""
			set _current ""
		}
		set num [.menu.window index end]
		for { set i 2 } { $i <= $num } { incr i } {
			set f2 [.menu.window entrycget $i -label]
			if { $f1 == $f2 } {
				.menu.window delete $i
				break
			}
		} 
		set objname [set obj($opr)]
		rename $objname {}
		destroy $opr
	}
	global RC$i1
	global xold$current recentid$current
	set xold$current 0
	set recentid$current 0
	set ro [$objname rows]
	set co [$objname cols]
	frame .t$i1.f1 -bg gray -borderwidth 5 -width 810 -height 350 
	frame .t$i1.f2 -bg gray -borderwidth 5 -width 810 -height 100 -relief groove -bd 4
	frame .t$i1.f1.f11 -borderwidth 5 -width 400 -height 310
	frame .t$i1.f1.f12 -borderwidth 5 -width 400 -height 310 -bg gray
	
	frame .t$i1.f1.f112 -height 20 -bg lightgrey -relief ridge -bd 3
	pack .t$i1.f1.f112 -side bottom -fill both -expand yes
	
	pack .t$i1.f1 -side top -fill both -expand yes
	pack .t$i1.f2 -side bottom -fill both -expand yes
	pack .t$i1.f1.f11 -side left -fill both -expand yes
	pack .t$i1.f1.f12 -side right -fill both -expand yes
	frame .t$i1.f1.f11.f111 -height 320 -width 330
	pack .t$i1.f1.f11.f111 -side top -fill both -expand yes
	canvas .t$i1.f1.f11.f111.c -scrollregion "0 0 $co $ro" -width 300 -height 300 -relief sunken -bg gray -xscrollcommand ".t$i1.f1.f11.f111.scrollx set" -yscrollcommand ".t$i1.f1.f11.f111.scrolly set" -borderwidth 2 -xscrollincrement 0.1i -yscrollincrement 0.1i  
	scrollbar .t$i1.f1.f11.f111.scrollx -orient horizontal -command ".t$i1.f1.f11.f111.c xview"
	scrollbar .t$i1.f1.f11.f111.scrolly -orient vertical -command ".t$i1.f1.f11.f111.c yview"
	pack .t$i1.f1.f11.f111.scrollx -side bottom  -fill x
	pack .t$i1.f1.f11.f111.c -side left -fill both -expand yes
	pack .t$i1.f1.f11.f111.scrolly -side right -fill y
	set f .t$i1.f1.f112
	
	set type1 [ eval set _typ$i1 ]
	if { $type1 == "P2"  ||  $type1 == "P5" } {
		label $f.l1 -text "ROW" -width 3 -bg lightgrey
		label $f.l2 -textvariable row.t$i1 -width 6 -relief sunken -bd 2
		label $f.l3 -text "COLUMN" -width 6 -bg lightgrey
		label $f.l4 -textvariable col.t$i1 -width 6 -relief sunken -bd 2
		label $f.l5 -text "GREYLEVEL" -width 9 -bg lightgrey
		label $f.l6 -textvariable grey.t$i1 -width 6 -relief sunken -bd 2
		pack $f.l1 $f.l2 $f.l3 $f.l4 $f.l5 $f.l6 -padx 2 -side left -fill x -expand yes
	} else { 
		frame $f.f1 -height 15 -width 50 -relief groove -bd 1
		pack $f.f1 -padx 2 -pady 2 -side left
		label $f.f1.l1 -text "ROW" -width 3 -bg lightgrey
		label $f.f1.l2 -textvariable row.t$i1 -width 4 -relief sunken -bd 1
		label $f.f1.l3 -text "COL" -width 3 -bg lightgrey
		label $f.f1.l4 -textvariable col.t$i1 -width 4 -relief sunken -bd 1
		pack $f.f1.l1 $f.f1.l2 $f.f1.l3 $f.f1.l4 -padx 1 -side left -fill x -expand yes
		
		frame $f.f2 -height 15 -width 50 -relief groove -bd 1
		pack $f.f2 -padx 2 -pady 2 -side left
		label $f.f2.l5 -text "R" -width 2 -bg lightgrey
		label $f.f2.l6 -textvariable grey.t$i1 -width 3 -relief sunken -bd 1
		label $f.f2.l7 -text "G" -width 2 -bg lightgrey
		label $f.f2.l8 -textvariable g.t$i1 -width 3 -relief sunken -bd 1
		label $f.f2.l9 -text "B" -width 2 -bg lightgrey
		label $f.f2.l10 -textvariable b.t$i1 -width 3 -relief sunken -bd 1
		pack $f.f2.l5 $f.f2.l6 $f.f2.l7 $f.f2.l8 $f.f2.l9 $f.f2.l10 -padx 1 -side left -fill x -expand yes
		
		frame $f.f3 -height 15 -width 50 -relief groove -bd 1
		pack $f.f3 -padx 2 -side left
		label $f.f3.l5 -text "H" -width 2 -bg lightgrey
		label $f.f3.l6 -textvariable h.t$i1 -width 4 -relief sunken -bd 1
		label $f.f3.l7 -text "S" -width 2 -bg lightgrey
		label $f.f3.l8 -textvariable s.t$i1 -width 4 -relief sunken -bd 1
		label $f.f3.l9 -text "V" -width 2 -bg lightgrey
		label $f.f3.l10 -textvariable v.t$i1 -width 3 -relief sunken -bd 1
		pack $f.f3.l5 $f.f3.l6 $f.f3.l7 $f.f3.l8 $f.f3.l9 $f.f3.l10 -padx 1 -side left -fill x -expand yes
		
		frame $f.f4 -height 15 -width 50  -relief groove -bd 1
		pack $f.f4 -padx 2 -side left
		label $f.f4.l5 -text "Y" -width 2 -bg lightgrey
		label $f.f4.l6 -textvariable y.t$i1 -width 3 -relief sunken -bd 1
		label $f.f4.l7 -text "I" -width 2 -bg lightgrey
		label $f.f4.l8 -textvariable i.t$i1 -width 4 -relief sunken -bd 1
		label $f.f4.l9 -text "Q" -width 2 -bg lightgrey
		label $f.f4.l10 -textvariable q.t$i1 -width 4 -relief sunken -bd 1
		pack $f.f4.l5 $f.f4.l6 $f.f4.l7 $f.f4.l8 $f.f4.l9 $f.f4.l10 -padx 1 -side left -fill x -expand yes
		
		frame $f.f5 -height 15 -width 50  -relief groove -bd 1
		pack $f.f5 -padx 2 -side left
		label $f.f5.l5 -text "X" -width 2 -bg lightgrey
		label $f.f5.l6 -textvariable x.t$i1 -width 3 -relief sunken -bd 1
		label $f.f5.l7 -text "Y" -width 2 -bg lightgrey
		label $f.f5.l8 -textvariable y1.t$i1 -width 3 -relief sunken -bd 1
		label $f.f5.l9 -text "Z" -width 2 -bg lightgrey
		label $f.f5.l10 -textvariable z.t$i1 -width 3 -relief sunken -bd 1
		pack $f.f5.l5 $f.f5.l6 $f.f5.l7 $f.f5.l8 $f.f5.l9 $f.f5.l10 -padx 1 -side left -fill x -expand yes
	}
	global img1.t$i1
	set img1.t$i1 [image create photo  -file $fn1 -palette 256/256/256 ]
	.t$i1.f1.f11.f111.c create image 0 0  -anchor nw -image [set img1.t$i1]
	set type1 [ eval set _typ$i1 ]
	if { $type1 == "P2"  ||  $type1 == "P5" } {
		label .t$i1.f2.l1 -text "ROWSxCOLS" -width 15 -bg gray 
		label .t$i1.f2.l2 -textvariable RC.t$i1 -width 15 
		label .t$i1.f2.l3 -text "INERTIA" -width 15 -bg gray
		label .t$i1.f2.l4 -textvariable  inertia.t$i1 -width 15 
		label .t$i1.f2.l5 -text "UNIFORMITY" -width 15 -bg gray
		label .t$i1.f2.l6 -textvariable  uniformity.t$i1 -width 15
		label .t$i1.f2.l7 -text "MINxMAX GRAY" -width 15 -bg gray
		label .t$i1.f2.l8 -textvariable  mx.t$i1 -width 15
		label .t$i1.f2.l9 -text "STDDEV" -width 15 -bg gray
		label .t$i1.f2.l10 -textvariable  dev.t$i1 -width 15
		label .t$i1.f2.l11 -text "ENTROPY" -width 15 -bg gray
		label .t$i1.f2.l12 -textvariable entropy.t$i1 -width 15
		label .t$i1.f2.l13 -text "MEAN" -width 15 -bg gray
		label .t$i1.f2.l14 -textvariable  mean.t$i1 -width 15 
		label .t$i1.f2.l15 -text "UNIFORMITY" -width 15 -bg gray
		label .t$i1.f2.l16 -textvariable  uniformity.t$i1 -width 15
		label .t$i1.f2.l17 -text "ROUGHNESS" -width 15 -bg gray
		label .t$i1.f2.l18 -textvariable  roughness.t$i1 -width 15
		label .t$i1.f2.l19 -text "STDDEV" -width 15 -bg gray
		label .t$i1.f2.l20 -textvariable  dev.t$i1 -width 15
		#label .t$i1.f2.l21 -text "ENCODED" -width 15 -bg gray
		label .t$i1.f2.l22 -textvariable enco.t$i1 -width 29 -bg gray
		button .t$i1.f2.b1 -text "SHOW DATA" -width 29 -command showdata
		button .t$i1.f2.b2 -text "SHOW HISTOGRAM" -width 29 -command "showhist 0 $i1"
		grid .t$i1.f2.l1 -row 1 -column 1 -padx 2 -pady 2
		grid .t$i1.f2.l2 -row 1 -column 2 -padx 2 -pady 2
		grid .t$i1.f2.l3 -row 4 -column 5 -padx 2 -pady 2
		grid .t$i1.f2.l4 -row 4 -column 6 -padx 2 -pady 2
		grid .t$i1.f2.l5 -row 1 -column 5 -padx 2 -pady 2
		grid .t$i1.f2.l6 -row 1 -column 6 -padx 2 -pady 2
		grid .t$i1.f2.l7 -row 2 -column 1 -padx 2 -pady 2
		grid .t$i1.f2.l8 -row 2 -column 2 -padx 2 -pady 2
		grid .t$i1.f2.l11 -row 2 -column 5 -padx 2 -pady 2
		grid .t$i1.f2.l12 -row 2 -column 6 -padx 2 -pady 2
		grid .t$i1.f2.l13 -row 3 -column 1 -padx 2 -pady 2
		grid .t$i1.f2.l14 -row 3 -column 2 -padx 2 -pady 2
		grid .t$i1.f2.l17 -row 3 -column 5 -padx 2 -pady 2
		grid .t$i1.f2.l18 -row 3 -column 6 -padx 2 -pady 2
		grid .t$i1.f2.l19 -row 4 -column 1 -padx 2 -pady 2           
		grid .t$i1.f2.l20 -row 4 -column 2 -padx 2 -pady 2
		grid .t$i1.f2.b1 -row 2 -column 3 -padx 2 -pady 2 -columnspan 2
		grid .t$i1.f2.b2 -row 3 -column 3 -padx 2 -pady 2 -columnspan 2
		#grid .t$i1.f2.l21 -row 1 -column 4 -padx 2 -pady 2
		grid .t$i1.f2.l22 -row 1 -column 3 -padx 2 -pady 2 -columnspan 2
	} else {
		frame .t$i1.f2.fc1 -width 150 -height 100 -bg lightgray -relief ridge -bd 3 
		label .t$i1.f2.fc1.l5 -text "Color Model" -bg lightgrey
		pack .t$i1.f2.fc1.l5 -side top -fill x -expand yes -padx 2 -pady 2
		frame .t$i1.f2.fc1.f5 -relief sunken -bg lightgrey -bd 2
		frame .t$i1.f2.fc1.f5.left
		frame .t$i1.f2.fc1.f5.right
		radiobutton .t$i1.f2.fc1.f5.r1 -text "RGB" -variable _model$i1 -value "RGB" -bg lightgrey -anchor nw -width 5 -selectcolor white -command "dispmodel2 $i1"
		radiobutton .t$i1.f2.fc1.f5.r2 -text "HSV" -variable _model$i1 -value "HSV" -bg lightgrey -anchor nw -width 5 -selectcolor white -command "dispmodel2 $i1"
		radiobutton .t$i1.f2.fc1.f5.r3 -text "XYZ" -variable _model$i1 -value "XYZ" -bg lightgrey -anchor nw -width 5 -selectcolor white -command "dispmodel2 $i1"
		radiobutton .t$i1.f2.fc1.f5.r4 -text "YIQ" -variable _model$i1 -value "YIQ" -bg lightgrey -anchor nw -width 5 -selectcolor white -command "dispmodel2 $i1"
		pack .t$i1.f2.fc1 -side left  -padx 2m
		pack .t$i1.f2.fc1.f5.left -side left
		pack .t$i1.f2.fc1.f5.right -side right
		pack .t$i1.f2.fc1.f5.r1 .t$i1.f2.fc1.f5.r2 -in .t$i1.f2.fc1.f5.left -side top  -padx 1 -pady 1 -expand yes -fill x
		pack .t$i1.f2.fc1.f5.r3 .t$i1.f2.fc1.f5.r4 -in .t$i1.f2.fc1.f5.right -side top  -padx 1 -pady 1 -expand yes -fill x
		pack .t$i1.f2.fc1.f5 -side top -fill x -expand yes -padx 2 -pady 2
		frame .t$i1.f2.f3 -width 100 -height 50 -bg gray -relief flat -bd 3
		label .t$i1.f2.f3.l1 -text "ROWSxCOLS" -width 15 -bg gray 
		label .t$i1.f2.f3.l2 -textvariable RC$i1 -width 15 
		pack  .t$i1.f2.f3.l1 .t$i1.f2.f3.l2 -side left -in .t$i1.f2.f3 -padx 2m -pady 2m
		pack  .t$i1.f2.f3 -side top -padx 2m -pady 2m
		
		frame .t$i1.f2.f4 -width 600 -height 50 -bg lightgray -relief ridge -bd 3
		button .t$i1.f2.f4.b1 -text "SHOW HIST FOR RED" -width 17 -command "showhist 1 $i1"
		button .t$i1.f2.f4.b2 -text "SHOW HIST FOR GREEN" -width 17 -command "showhist 2 $i1"
		button .t$i1.f2.f4.b3 -text "SHOW HIST FOR BLUE" -width 17 -command "showhist 4 $i1"		
		pack .t$i1.f2.f4.b1  .t$i1.f2.f4.b2 .t$i1.f2.f4.b3 -side left -in .t$i1.f2.f4 -padx 2m -pady 2m
		pack .t$i1.f2.f4 -side bottom -padx 2m -pady 2m
		
		set RC$i1 [$objname cget -drows]x[$objname cget -dcols]		
	}
	proc dispmodel2 { fr } {
		global _model$fr
		
		set x [ eval set _model$fr ]
		if { $x == "RGB" } {
			.t$fr.f2.f4.b1 configure -text "SHOW HIST FOR RED"
			.t$fr.f2.f4.b2 configure -text "SHOW HIST FOR GREEN"
			.t$fr.f2.f4.b3 configure -text "SHOW HIST FOR BLUE"
		} elseif { $x == "HSV" } {
			.t$fr.f2.f4.b1 configure -text "SHOW HIST FOR VALUE"
			.t$fr.f2.f4.b2 configure -text "SHOW HIST FOR HUE"
			.t$fr.f2.f4.b3 configure -text "SHOW HIST FOR SAT"
		} elseif { $x == "YIQ" } {
			.t$fr.f2.f4.b1 configure -text "SHOW HIST FOR Y"
			.t$fr.f2.f4.b2 configure -text "SHOW HIST FOR I"
			.t$fr.f2.f4.b3 configure -text "SHOW HIST FOR Q"
		} elseif { $x == "XYZ" } {
			.t$fr.f2.f4.b1 configure -text "SHOW HIST FOR Y"
			.t$fr.f2.f4.b2 configure -text "SHOW HIST FOR X"
			.t$fr.f2.f4.b3 configure -text "SHOW HIST FOR Z"
		}
	}
	canvas .t$i1.f1.f12.c -width 390 -height 200 -bg lightgray -relief sunken -bd 3   
	frame .t$i1.f1.f12.f121 -width 390 -height 150 -bg lightgrey -relief ridge -bd 3
	set ff .t$i1.f1.f12.f121
	label $ff.l1 -text "PIXEL VALUE" -width 23 -bg lightgrey -anchor nw
	label $ff.l3 -text "NUMBER OF PIXELS" -width 23  -bg lightgrey -anchor nw
	label $ff.l5 -text "\%ILE OF PIXELS UPTO" -width 23  -bg lightgrey -anchor nw
	label $ff.l2 -textvariable "gl.t$i1" -width 15 -bg white
	label $ff.l4 -textvariable pg.t$i1 -width 15 -bg white
	label $ff.l6 -textvariable pl.t$i1 -width 15 -bg white
	pack .t$i1.f1.f12.c -side top -fill both -expand yes
	pack $ff -side bottom -fill both -expand yes -pady 6
	grid $ff.l1 -row 1 -column 1 -padx 4 -pady 2
	grid $ff.l2 -row 1 -column 2 -padx 6 -pady 2
	grid $ff.l3 -row 2 -column 1 -padx 4 -pady 2
	grid $ff.l4 -row 2 -column 2 -padx 6 -pady 2
	grid $ff.l5 -row 3 -column 1 -padx 4 -pady 2
	grid $ff.l6 -row 3 -column 2 -padx 6 -pady 2
	
	.t$i1.f1.f12.c bind dispgrey <1> {
		global obj current maximu
		global xold$current recentid$current
		global gl$current pg$current pl$current
		set current %W
		set path %W
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set c $current.f1.f12.c
		set x1 %x
		set y1 190
		set temp2 [expr $x1 - 20]
		if { $temp2 >= 0 } { 
			if { $temp2 < 361 } {
				set y21 [$objname histval $temp2 $maximu]
				set y2 [expr $y1 - $y21]
				set temp1 [set recentid$current]
				$c itemconfigure $temp1 -tags dispgrey -fill black 
				set recentid$current [$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill white]
				set xold$current $temp2
				set gl$current $temp2
				set pg$current [$objname cget -histvalue $temp2 $maximu]
				set pl$current [$objname cget -histile $temp2 $maximu]
			}
		}
	}
	
	.t$i1.f1.f12.c bind dispgrey <Button1-Motion> {
		global obj current maximu
		global xold$current recentid$current
		global gl$current pg$current pl$current
		set current %W
		set path %W
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set c $current.f1.f12.c
		set x1 %x
		set y1 190
		set temp2 [expr $x1 - 20]
		if { $temp2 >= 0 } { 
			if { $temp2 < 361 } {
				set y21 [$objname histval $temp2 $maximu]
				set y2 [expr $y1 - $y21]
				set temp1 [set recentid$current]
				$c itemconfigure $temp1 -tags dispgrey -fill black 
				set recentid$current [$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill white]
				set xold$current $temp2
				set gl$current $temp2
				set pg$current [$objname cget -histvalue $temp2 $maximu]
				set pl$current [$objname cget -histile $temp2 $maximu]
			}
		}
	}
	.t$i1.f1.f12.c bind moveright <1> {
		global obj current maximu
		global xold$current recentid$current 
		global gl$current pg$current pl$current
		set current %W
		set path %W
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set c $current.f1.f12.c
		set temp1 [set recentid$current]
		set temp2 [set xold$current]
		$c itemconfigure $temp1 -tags dispgrey -fill black 
		set xold$current [$objname increment255 $temp2]
		set temp2 [set xold$current]
		set x1 [expr $temp2 + 20]
		set y1 190
		set y21 [$objname histval $temp2 $maximu]
		set y2 [expr $y1 - $y21]
		set recentid$current [$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill white]
		set gl$current $temp2
		set pg$current [$objname cget -histvalue $temp2 $maximu]
		set pl$current [$objname cget -histile $temp2 $maximu]
	}
	
	.t$i1.f1.f12.c bind moveleft <1> {
		global obj current maximu
		global xold$current recentid$current 
		global gl$current pg$current pl$current
		set current %W
		set path %W
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set c $current.f1.f12.c
		set temp1 [set recentid$current]
		set temp2 [set xold$current]
		$c itemconfigure $temp1 -tags dispgrey -fill black 
		set xold$current [$objname decrement255 $temp2]
		set temp2 [set xold$current]
		set x1 [expr $temp2 + 20]
		set y1 190
		set y21 [$objname histval $temp2 $maximu]
		set y2 [expr $y1 - $y21]
		set recentid$current [$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill white]
		set gl$current $temp2
		set pg$current [$objname cget -histvalue $temp2 $maximu]
		set pl$current [$objname cget -histile $temp2 $maximu]
	}
	bind .t$i1.f1.f11.f111.c  <Motion> {
		global obj current 
		set current %W
		set path %W
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set col [$path canvasx %x]
		set row [$path canvasy %y]
		set cl [string length $col]
		set rl [string length $row]
		incr cl -3
		incr rl -3
		set coltemp [string range $col 0 $cl]
		set rowtemp [string range $row 0 $rl]
		if { ($coltemp >= 0) && ($rowtemp >= 0) } {
			set col$current $coltemp
			set row$current $rowtemp
			set j [catch { [set img1$current] get [set col$current] [set row$current] } grey]
			if {$j == 0 } {
				set grey$current [lindex $grey 0]
				set g$current [lindex $grey 1]
				set b$current [lindex $grey 2]
				
				set r [lindex $grey 0]
				set g [lindex $grey 1]
				set b [lindex $grey 2]
				
				set y$current [ expr int(0.299 * $r + 0.587 * $g + 0.114 * $b) ]
				set i$current [ expr int(0.596 * $r - 0.275 * $g - 0.321 * $b) ]
				set q$current [ expr int(0.212 * $r - 0.523 * $g + 0.311 * $b) ]
				
				set y1$current [ expr int(0.212671 * $r + 0.715160 * $g + 0.072169 * $b)]
				set x$current [ expr int(0.412453 * $r + 0.357580 * $g + 0.180423 * $b) ]
				set z$current [ expr int(0.019334 * $r + 0.119193 * $g + 0.950227 * $b) ]
				
				set v [ expr ( $r + $g + $b ) / 3 ]
				set v$current [ expr int($v) ]
				
				set ang 0
				if { $r != $v || $g != $v || $b != $v} {	
					set ang [ expr ( 0.5 * ( ( $r - $g ) + ( $r - $b ) ) ) / ( sqrt ( ( $r - $g ) * ( $r - $g ) + ( $r - $b ) * ( $g - $b ) ) ) ]
				} else {
					set ang 1
				}
				set teta [ expr acos($ang)  * 180 * 7.0 / 22.0 ]
				if { $b > $g } {
					set h$current [ expr int(360 - $teta) ]
				} else {
					set h$current  [ expr int($teta) ]
				}
				
				if { $r < $g } { 
					if { $r < $b } { 
						set min [ expr $r ]
					} else { 
						set min [ expr $b ]
					}
				} else { 
					if { $g < $b } { 
						set min [ expr $g ]
					} else { 
						set min [ expr $b ]
					}
				}
				if { $v == 0 } { 
					set  s$current  0
				} else {
					set temp [ expr $min / $v ]
					set s$current [ expr int(100 - $min*100 / $v) ]
				}
				
				
			} else {
				set grey$current ***
				set g$current ***
				set b$current ***
				
				set h$current ***
				set s$current ***
				set v$current ***
				
				set y$current ***
				set i$current ***
				set q$current ***
				
				set x$current ***
				set y1$current ***
				set z$current ***
				
			}
		}
		#set grey$current [$objname getgray $row $col]
	}
	bind .t$i1.f1.f11.f111.c  <Shift-1> {
		global obj current _current 
		global _bx$current _by$current _tx$current _ty$current
		set current %W
		set path %W
		catch {$path delete recta} j 
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set _bx$current [$path canvasx %x]
		set _by$current [$path canvasy %y]
		set rows [$obj([set current]) cget -drows]
		set cols [$obj([set current]) cget -dcols]
		if { [set _bx$current] > $cols } {
			set _bx$current $cols
			incr _bx$current -1
		} 
		if { [set _by$current] > $rows } {
			set _by$current $rows
			incr _by$current -1
		} 
		$path create rectangle [set _tx$current] [set _ty$current] [set _bx$current] [set _by$current] -width 1 -tags recta
	}
	
	bind .t$i1.f1.f11.f111.c  <1> {
		global obj current _tx$current _ty$current _current _px$current _py$current
		global id$_current
		set current %W
		set path %W
		catch {$path delete recta} j 
		set r [string first .f $current]
		incr r -1
		set current [string range $current 0 $r] 
		set objname [set obj($current)]
		set _tx$current [$path canvasx %x]
		set _ty$current [$path canvasy %y]
		set _px$current [$path canvasx %x]
		set _py$current [$path canvasy %y]
		set rows [$obj([set current]) cget -drows]
		set cols [$obj([set current]) cget -dcols]
		if { [set _tx$current] > $cols } {
			set _tx$current 0    
		} 
		if { [set _ty$current] > $rows } {
			set _ty$current 0
		} 
		if { [set _px$current] > $cols } {
			set _px$current 0    
		} 
		if { [set _py$current] > $rows } {
			set _py$current 0
		} 
	}
}


proc showhist { op fr } {
	global current obj _model$fr _typ$fr maximu
	global xold$current recentid$current
	global gl$current pg$current pl$current
	set c $current.f1.f12.c
	set objname [set obj($current)]
	set type1 [ eval set _typ$fr ]
	if { $type1 == "P3"  ||  $type1 == "P6" } {
		set model1 [ eval set _model$fr ]
	}
	if { $op == 0 } {
		$objname histinit
	} else {
		$objname histinit -model $model1 -flags $op
	}
	$c create line 20 190 380 190
	$c create line 20 210 50 210 -arrow first -width 10 -tags moveleft 
	$c create line 365 210 385 210 -arrow last -width 10 -tags moveright
	set x1 20
	set y1 190
	
	set maxi 255
	if { $op == 2 && $model1 == "HSV" } {
		set maxi 359
	}
	if { $op == 4 && $model1 == "HSV" } {
		set maxi 100
	}
	set maximu $maxi
	for { set i 0 } { $i <= 360 } { incr i } {
		set y21 [$objname histval $i $maxi]
		set y2 0
		$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill lightgrey
		incr x1 1
	}
	set x1 20
	set y1 190	
	for { set i 0 } { $i <= $maxi } { incr i } {
		set y21 [$objname histval $i $maxi]
		set y2 [expr $y1 - $y21]
		if { $op == 0 } {
			$c create line $x1 $y1 $x1 $y2 -tags dispgrey
		} elseif { $op == 1 } { 
			$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill red
		} elseif { $op == 2 } { 
			$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill green
		} else {
			$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill blue
		}
		incr x1 1
	}
	set xold$current 0
	set x1 20
	set y21 [$objname histval 0 $maxi]
	set y2 [expr $y1 - $y21]
	set recentid$current [$c create line $x1 $y1 $x1 $y2 -tags dispgrey -fill white]
	set gl$current 0 
	set pg$current [$objname cget -histvalue 0 $maxi]
	set pl$current [$objname cget -histile 0 $maxi]
}  
proc showdata {} {
	global current obj x
	global mean$current dev$current RC$current mx$current inertia$current uniformity$current roughness$current entropy$current enco$current
	set objname [set obj($current)]
	set j [$objname ver]
	if { $j == 0 } { set enco$current "BINARY ENCODED"}
	if { $j == 1 } { set enco$current "ASCII ENCODED"}
	
	$objname histinit
	$objname texinit
	
	set RC$current [$objname cget -drows]x[$objname cget -dcols]
	set mx$current [$objname cget -ming]x[$objname cget -maxg]
	set mean$current [$objname cget -mean]
	set dev$current [$objname cget -dev]
	set inertia$current [$objname cget -inertia]
	set uniformity$current [$objname cget -uniformity]
	set roughness$current [$objname cget -roughness]
	set entropy$current [$objname cget -entropy]
}

proc zoom {} {
	global _current obj _current1
	global img1$_current _zx _zy _id
	set _zx 0
	set _zy 0
	if { $_current=="" } {
		error "set a file"
		return 0
	}
	set objname [set obj($_current)]
	catch {destroy .zoom}
	toplevel .zoom -bg black
	wm geometry .zoom =800x580+0+0
	wm title .zoom "$_current1 FULL VIEW"
	bind .zoom <Escape> {
		rename zoomimg {}
		destroy .zoom
	}
	#bind .zoom <B2-ButtonPress> {
		#destroy .zoom
	#}
	set ro [$objname cget -drows]
	set co [$objname cget -dcols]
	canvas .zoom.c -scrollregion "0 0 $co $ro" -width 750 -height 550 -relief sunken -bg gray -xscrollcommand ".zoom.scrollx set" -yscrollcommand ".zoom.scrolly set" -borderwidth 2 -xscrollincrement 0.1i -yscrollincrement 0.1i -bg black
	scrollbar .zoom.scrollx -orient horizontal -command ".zoom.c xview"
	scrollbar .zoom.scrolly -orient vertical -command ".zoom.c yview"
	pack .zoom.scrollx -side bottom  -fill x
	pack .zoom.c -side left -fill both -expand yes
	pack .zoom.scrolly -side right -fill y
	image create photo zoomimg -width 0 -height 0
	zoomimg copy [set img1$_current]
	set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
	bind .zoom.c <1> "zoom1  [set img1$_current] $co $ro"  
	bind .zoom.c <3> "zoom2  [set img1$_current] $co $ro"  
}
proc zoom1 {img co ro } {
	global _zx _zy _id
	incr _zx
	incr _zy
	rename zoomimg {}
	image create photo zoomimg -width 0 -height 0
	if {($_zx >= 1) && ($_zy >=1)} {
		zoomimg copy $img -zoom [expr $_zx+1] [expr $_zy+1]
		.zoom.c delete $_id
		.zoom.c configure -scrollregion "0 0 [expr $co*($_zx+1)] [expr $ro*($_zy+1)]"
		set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
		update
	}
	if {($_zx == 0)&& ($_zy == 0)} {
		zoomimg copy $img 
		.zoom.c delete $_id
		.zoom.c configure -scrollregion "0 0 [expr $co*($_zx+1)] [expr $ro*($_zy+1)]"
		set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
		update
	}
	if {($_zx < 0) && ($_zy < 0)} {
		zoomimg copy $img -subsample [expr -1*$_zx+1] [expr -1*$_zy+1]
		.zoom.c delete $_id
		set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
		update
	}
}
proc zoom2 {img co ro } {
	global _zx _zy _id
	incr _zx -1
	incr _zy -1
	rename zoomimg {}
	image create photo zoomimg -width 0 -height 0
	if {($_zx >= 1) && ($_zy >=1)} {
		zoomimg copy $img -zoom [expr $_zx+1] [expr $_zy+1]
		.zoom.c delete $_id
		.zoom.c configure -scrollregion "0 0 [expr $co*($_zx+1)] [expr $ro*($_zy+1)]"
		set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
		update
	}
	if {($_zx == 0)&& ($_zy == 0)} {
		zoomimg copy $img 
		.zoom.c delete $_id
		.zoom.c configure -scrollregion "0 0 [expr $co*($_zx+1)] [expr $ro*($_zy+1)]"
		set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
		update
	}
	if {($_zx < 0) && ($_zy < 0)} {
		zoomimg copy $img -subsample [expr -1*$_zx+1] [expr -1*$_zy+1]
		.zoom.c delete $_id
		set _id [.zoom.c create image 0 0 -image zoomimg -anchor nw]
		update
	}
}
