#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <errno.h>
#include "incl.h"
#include "cipl.h"

main(int argc, char *argv[]) {
  int i, j, max;
  int arr[2]={1200,2400};
  THEADER *it, *ot, *temp, *temp1, *temp2;
  DATA *ID;
  
  HIPL_Setmemory(500);
  
  it=(THEADER *)malloc(sizeof(THEADER));
  ot=(THEADER *)malloc(sizeof(THEADER));
  temp=(THEADER *)malloc(sizeof(THEADER));
  temp1=(THEADER *)malloc(sizeof(THEADER));
  temp2=(THEADER *)malloc(sizeof(THEADER));
  
  ID=(DATA *)malloc(sizeof(DATA));
  HIPL_Initialise(it,argv[1],0,0,ID);
  HIPL_Initialise(ot,NULL,1,0,ID);
  HIPL_Initialise(temp,NULL,1,0,ID);
  HIPL_Initialise(temp1,NULL,1,0,ID);
  HIPL_Initialise(temp2,NULL,1,0,ID);
  
  HIPL_AllocateMem(it);
  HIPL_AllocateMem(ot);
  HIPL_AllocateMem(temp);
  HIPL_AllocateMem(temp1);
  HIPL_AllocateMem(temp2);
  
  /*CIPL_Medcut(it, ot, 128);
  CIPL_Octree(it, ot,5,128);*/
  
  //CIPL_IdealPass(it, ot, 128, 128, 128, 100, 100, 100);
  //CIPL_IdealReject(it, ot, 128, 128, 128, 100, 100, 100);
  //CIPL_ButterworthPass(it,ot,128,128,128,100,100,100,1);
  //CIPL_ButterworthReject(it, ot, 128, 128, 128, 100, 100, 100, 1);
  
  CIPL_rgbtohsi(it,temp); 
  
  //CIPL_log(temp,temp1,4);
  
  //CIPL_HuePolarisation1(temp, temp1, 100, arr,2);
  CIPL_SatuVariation(temp, temp1, 50);
  
  //CIPL_HSIIdealPass(temp, temp1, 2400, 1000);
  //CIPL_HSIIdealReject(temp, temp1, 2400, 1000);
  //CIPL_HSIButterworthPass(temp, temp1, 0, 700, 1);
 // CIPL_HSIButterworthReject(temp, temp1, 0, 1000, 1);  
  //CIPL_Scale(temp,temp1,0.1,2);
  //CIPL_FindHistogram(temp1,ID,100,2);
  //CIPL_SatuStr(temp1,temp2,ID->hist,75,50);
  //CIPL_SatuEqualise(temp1,temp2,ID->hist);
  //HIPL_Refresh(temp1,0);
  //CIPL_Scale(temp2,temp1,10,2);
  
  CIPL_hsitorgb(temp1,ot);
   
   
  // CIPL_rgbtohsi(it, temp);
  //CIPL_Scale(temp, temp1, 0.1,1);
  
  //HIPL_Maskinit(temp, 3, 3, 1, 1);
  //HIPL_Maskinit(temp1,3, 3, 1, 1);
    
  //CIPL_Smoothing(temp,temp1, 2);
  //CIPL_Highpass(temp1, temp2, 1);

  //CIPL_Medianmask(temp,temp1,7);
  //CIPL_Gaussavg(temp,temp1,1,7); 
    
  //CIPL_Sobel(temp1, temp2, 1);
  //CIPL_Prewitts(temp1, temp2, 1);
  //CIPL_Kirsch(temp1, temp2, 1);
  
  /*HIPL_Maskinit(temp1, 2, 2, 0, 0);
  HIPL_Maskinit(temp2,2, 2, 0, 0);
  CIPL_Roberts(temp1, temp2, 1);*/
  
  //HIPL_Refresh(temp1,0);
  //CIPL_Scale(temp2,temp1,10,1);

  //CIPL_hsitorgb(temp1, ot);
  //CIPL_rgbtoxyz(it,temp1);
  //CIPL_XYZfilter(temp1,temp2,487,2,1);
  //CIPL_xyztorgb(temp2,ot); 
  //CIPL_XYZfilter(it,ot,450,50,1);
  HIPL_StoreResult(argv[2], ot);

  HIPL_FreeMem(it);
  HIPL_FreeMem(ot);
  HIPL_FreeMem(temp);
  HIPL_FreeMem(temp1);
  HIPL_FreeMem(temp2);
  
  HIPL_Closeall(it);
  HIPL_Closeall(ot);
  HIPL_Closeall(temp);
  HIPL_Closeall(temp1);
  HIPL_Closeall(temp2);
  
  free(ID);
  free(it);
  free(ot);
  free(temp);
  free(temp1);
  free(temp2);
}
