#include<stdio.h>
#include<malloc.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<errno.h>
#include"err_hipl.h"

#define  ISUNIX 1 
#define  PGM  10
#define  TIFF 20
#define  PPM  40
#define  RGB  40
#define  HSV  50
#define  YIQ  60
#define  XYZ  70
#define  RAW  30
#define  UNKNOWN 99 
#define  BINARY 0
#define  ASCII 1

#define RED	0
#define GREEN	1
#define BLUE	2
#define HSV_VALUE   0
#define HSV_HUE     1
#define HSV_SAT     2
#define HUE	1
#define SAT	2
#define VALUE	4

#ifdef EBUG
#define DB_printf(A)	printf A
#else
#define DB_printf(A)	;
#endif

typedef struct{
	int psize;
	int rowsread;
	int nleft;
	int put;
}parts;

typedef struct{
	int ROWS;
	int COLS;
	int levels;
	int TYPE;
}IMGHEADER;

typedef struct{
	int ROWS;
	int COLS;
	short ver;
        int type;
	long int *hist;
	float inertia;
	float uniformity;
	float entropy;
	float roughness;
	int maxg;
	int ming;
	int mean;
	int dev;
}DATA;

typedef struct {
	FILE *fptr, *jptr, *kptr;
	char tempfname[35];
        char tempjname[35];
        char tempkname[35];
	int **iarr;		/* Stores R values for colour images */
        int **jarr;		/* Stores G values for colour images */
        int **karr;		/* Stores B values for colour images */
	float **farr;
	int MORGX;
	int MORGY;
	int MROWS;
	int MCOLS;	
	parts P;
	short dfflg;
	short arrtype;
	short ver;
	short memflag;
	IMGHEADER img;
} THEADER;
typedef THEADER HIPL_IMAGE;

typedef struct {
	char fname[100];
	THEADER *T;
	DATA *ID;
} HEADER;

typedef struct {
          int label;
          int xmin;
          int ymin;
          int xmax;
          int ymax;
} MBRSTRUCT;

extern int HIPL_ERRNO;
extern char WINERR[];
