global _current typ _colo
# source filebox.tcl
# source prj.tcl
auto_mkindex [pwd] /home2/chakcs/public_html/dip11/ciptk/filebox.tcl \
    /home2/chakcs/public_html/dip11/ciptk/prj.tcl
#	prj10.tcl
lappend auto_path [pwd]
set _current "" 
set _user 1
set _filter 1
set _model "RGB"
set _i 1
set _type 0
set _colo 1
set w ""
global projecttcl123 
set projecttcl123 9999
. configure -bg lightgrey
wm geometry . =820x500+0+0
wm title . "An Color Image Processing Tool Kit - CIPGUI"
wm protocol . WM_DELETE_WINDOW confirmdw
proc deletewindow {} {
	destroy .
	set j [catch {glob HIPL_*.pgm} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	set j [catch {glob CIPL_*.ppm} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	set j [catch {glob IPL_Cnv*.pgm} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
	set j [catch {glob hipl*.idt} files]
	if { $j == 0 } {
		foreach i $files {
			file delete $i
		}
	}
}
proc confirmdw {} {
	toplevel .confirmdw -bg lightgrey -bd 5 -relief ridge
	set t .confirmdw
	wm title $t "Confirmation for QUITTING"
	wm geometry $t +300+200
	frame $t.top -bg lightgrey
	label $t.top.icon -bitmap questhead -bg lightgrey
	set j [catch {glob HIPL_*.pgm} files]
	if { $j == 0 } {
		set mesg "Unsaved files exist, do you still want to quit IPGUI ?"
	} else {
		set mesg "Do you really want to quit IPGUI ?"
	}
	set j [catch {glob CIPL_*.ppm} files]
	if { $j == 0 } {
		set mesg "Unsaved files exist, do you still want to quit IPGUI ?"
	} else {
		set mesg "Do you really want to quit IPGUI ?"
	}
	label $t.top.mesg -text $mesg -bg lightgrey
	pack $t.top.icon -side left
	pack $t.top.mesg -side right -expand yes
	frame $t.sep -height 2 -bd 1 -relief sunken -bg lightgrey
	frame $t.controls -bg lightgrey 
	button $t.controls.ok -text "YES"  -bg lightgrey -command "destroy $t ; deletewindow"
	button $t.controls.cancel -text "CANCEL"  -bg lightgrey -command "destroy $t"
	pack $t.controls.ok -side left -padx 4 -expand yes
	pack $t.controls.cancel -side left -padx 4 -expand yes
	pack $t.top -padx 8 -pady 8 -expand yes -fill both
	pack $t.sep -fill x -pady 4
	pack $t.controls -pady 4 -fill x
	wm overrideredirect $t 1
	grab set $t
}
proc savecall file1 {
	toplevel .savecall -bg lightgrey -bd 5 -relief ridge
	set t .savecall
	wm title $t "Confirmation for SAVING"
	wm geometry $t +300+200
	frame $t.top -bg lightgrey
	label $t.top.icon -bitmap questhead -bg lightgrey
	label $t.top.mesg -text "Do you like to save $file1 ?" -bg lightgrey
	pack $t.top.icon -side left
	pack $t.top.mesg -side right -expand yes
	frame $t.sep -height 2 -bd 1 -relief sunken -bg lightgrey
	frame $t.controls -bg lightgrey 
	button $t.controls.ok -text "YES"  -bg lightgrey -command "destroy $t ; savecall2 $file1"
	button $t.controls.cancel -text "NO"  -bg lightgrey -command "destroy $t ; file delete $file1"
	pack $t.controls.ok -side left -padx 4 -expand yes
	pack $t.controls.cancel -side left -padx 4 -expand yes
	pack $t.top -padx 8 -pady 8 -expand yes -fill both
	pack $t.sep -fill x -pady 4
	pack $t.controls -pady 4 -fill x
	wm overrideredirect $t 1
	grab set $t
}
proc delcall file1 {
	toplevel .delcall -bg lightgrey -bd 5 -relief ridge
	set t .delcall
	wm title $t "Confirmation for DELETING"
	wm geometry $t +300+200
	frame $t.top -bg lightgrey
	label $t.top.icon -bitmap questhead -bg lightgrey
	label $t.top.mesg -text "You Really want to delete $file1 ?" -bg lightgrey
	pack $t.top.icon -side left
	pack $t.top.mesg -side right -expand yes
	frame $t.sep -height 2 -bd 1 -relief sunken -bg lightgrey
	frame $t.controls -bg lightgrey 
	button $t.controls.ok -text "YES"  -bg lightgrey -command "destroy $t ; rm2 $file1"
	button $t.controls.cancel -text "NO"  -bg lightgrey -command "destroy $t"
	pack $t.controls.ok -side left -padx 4 -expand yes
	pack $t.controls.cancel -side left -padx 4 -expand yes
	pack $t.top -padx 8 -pady 8 -expand yes -fill both
	pack $t.sep -fill x -pady 4
	pack $t.controls -pady 4 -fill x
	wm overrideredirect $t 1
}

bind . <Control-o> "imgopen"
menu $w.menu -tearoff 0
set f $w.menu.file

menu $f -tearoff 0
$w.menu add cascade -label "File" -menu $f -underline 0
$f add command -label "New" -command newimage
$f add command -label "Open..." -command imgopen -accelerator Control+o
$f add separator
$f add command -label "Save As..." -command imgsave
$f add command -label "Make a Copy" -command imgcopy
$f add command -label "Preferences" -command setprefer  
$f add separator
$f add command -label "Delete" -command imgdelete 
$f add command -label "Close" -command { rm1 $_current}
$f add command -label "Exit" -command confirmdw
set e $w.menu.edit
menu $e -tearoff 0
$w.menu add cascade -label "Edit" -menu $e -underline 0 
$e add command -label "Select" -command imgselect 
$e add command -label "Paste" -command imgpaste
set i $w.menu.image
menu $i -tearoff 0
$w.menu add cascade -label "Image" -menu $i -underline 0
$i add command -label "Full View" -command zoom 
$i add command -label "Transpose" -command "singleopr transpose"
$i add command -label "H Flip" -command "singleopr hflip"
$i add command -label "Equalise" -command "singleopr equalise"
menu $i.stretch -tearoff 0
$i add cascade -label "Stretch" -menu $i.stretch
$i.stretch add command -label "Linear" -command "pointcall stretch"
$i.stretch add command -label "Logorthmic" -command "singleopr lstretch"
$i.stretch add command -label "Incremental" -command "pointcall istretch"
$i add command -label "Double" -command "singleopr double"

set p $w.menu.point
menu $p -tearoff 0
$w.menu add cascade -label "Point" -menu $p -underline 0
$p add command -label "Negative" -command "singleopr neg"
$p add command -label "Bit plane" -command "pointcall bpslice"
$p add command -label "Range" -command "pointcall range"
$p add command -label "Difference" -command "pointcall difference"
$p add command -label "Threshold" -command "pointcall threshold"
$p add command -label "SuperImpose" -command "pointcall addition"

set ed $w.menu.edge
menu $ed -tearoff 0
$w.menu add cascade -label "Edge" -menu $ed -underline 0
$ed add command -label "Sobel" -command "singleopr sobel"
$ed add command -label "Roberts" -command "singleopr roberts"
$ed add command -label "Prewitts" -command "singleopr prewitts"
$ed add command -label "Kirsch" -command "singleopr kirsch"
$ed add command -label "Canny" -command "filtercall canny"

set f $w.menu.filters
menu $f -tearoff 0
$w.menu add cascade -label "Filter" -menu $f -underline 3
$f add command -label "Low pass" -command "filtercall mlowpass"
$f add command -label "High pass" -command "filtercall mhighpass"
$f add command -label "High boost" -command "filtercall highboost"
$f add command -label "Gaussian" -command "filtercall gaussian"
$f add command -label "Median" -command "filtercall applymedian"
$f add command -label "Generic Mask" -command "filtercall applymask"
$f add separator
$f add radiobutton -label "Default" -variable _user -value 0 
$f add radiobutton -label "User Defined" -variable _user -value 1


set m $w.menu.morphology
menu $m -tearoff 0
$w.menu add cascade -label "Morphology" -menu $m -underline 0
$m add command -label "Dilate" -command "morphcall dilate"
$m add command -label "Erode" -command "morphcall erode"
$m add command -label "Open" -command "morphcall open"
$m add command -label "Close" -command "morphcall close"
$m add separator
$m add radiobutton -label "Binary" -variable _type -value 0
$m add radiobutton -label "Grey Level" -variable _type -value 1
$m add separator
$m add radiobutton -label "Default" -variable _user -value 0
$m add radiobutton -label "User Defined" -variable _user -value 1


set c $w.menu.frequency
menu $c -tearoff 0
$w.menu add cascade -label "Frequency" -menu $c -underline 0
$c add command -label "FFT" -command "singleopr fft"
$c add separator
$c add command -label "Low pass" -command "fftcall flowpass"
$c add command -label "High pass" -command "fftcall fhighpass"
$c add command -label "Butter worth low pass" -command "fftcall fbwlowpass"
$c add command -label "Butter worth High pass" -command "fftcall fbwhighpass"
$c add command -label "Band pass" -command "fftcall fbandpass"
$c add command -label "Band Reject" -command "fftcall fbandreject"
$c add separator
$c add radiobutton -label "FFT Filters" -variable _filter -value 0
$c add radiobutton -label "FIR Filter" -variable _filter -value 1
$c add radiobutton -label "IIR Filter" -variable _filter -value 2
$c add separator
$c add radiobutton -label "Default" -variable _user -value 0
$c add radiobutton -label "User Defined" -variable _user -value 1

set d $w.menu.advance
menu $d -tearoff 0
$w.menu add cascade -label "Advanced" -menu $d -underline 0
$d add command -label "Thin" -command "singleopr thin"
$d add command -label "Connected component" -command "singleopr connect"

set q $w.menu.quantize
menu $q -tearoff 0
$w.menu add cascade -label "Quantize" -menu $q -underline 0
$q add command -label "Medcut" -command "coloropr medcut"
$q add command -label "Octree" -command "coloropr octree"

set c $w.menu.cfilters
menu $c -tearoff 0
$w.menu add cascade -label "ColorFilter" -menu $c -underline 0
$c add command -label "Ideal Pass" -command "coloropr idealpass"
$c add command -label "Ideal Reject" -command "coloropr idealreject"
$c add command -label "Butterworth Pass" -command "coloropr butterworthpass"
$c add command -label "Butterworth Reject" -command "coloropr butterworthreject"
$c add command -label "HSI Ideal Pass" -command "coloropr hsiidealpass"
$c add command -label "HSI Ideal Reject" -command "coloropr hsiidealreject"
$c add command -label "HSI Butterworth Pass" -command "coloropr hsibutterworthpass"
$c add command -label "HSI Butterworth Reject" -command "coloropr hsibutterworthreject"
$c add command -label "XYZ Filter" -command "coloropr xyzfilter"

set mis $w.menu.misc
menu $mis -tearoff 0
$w.menu add cascade -label "Misce" -menu $mis -underline 0
$mis add command -label "Hue Polarise" -command "coloropr huepolarise"
$mis add command -label "Extract Plane" -command "singleopr extract"
$mis add command -label "Satu Variation" -command "coloropr satuvariation"

set wi1 $w.menu.window
menu $wi1 -tearoff 0
$w.menu add cascade -label "Window" -menu $wi1 -underline 0
$wi1 add command -label "Iconify all" -command iconcall
$wi1 add separator

set h $w.menu.help
menu $h -tearoff 0
$w.menu add cascade -label "Help" -menu $h -underline 0
$h add command -label "About..." -command ahelp

. configure -menu $w.menu
pack propagate . false

frame .newimg -bg lightgrey -bd 4 -relief ridge
label .newimg.l1 -text "New Image Parameters" -bg lightgray
pack .newimg.l1 -side top -expand yes -fill x
frame .newimg.f2 -bg lightgray -bd 3 -relief sunken
label .newimg.f2.lwidth -text "Width" -bg lightgrey
entry .newimg.f2.ewidth -width 6 -textvariable _width -state normal -bg white
label .newimg.f2.lheight -text "Height" -bg lightgrey
entry .newimg.f2.eheight -width 6 -textvariable _height -state normal -bg white
label .newimg.f2.lgrey -text "Max" -bg lightgrey
entry .newimg.f2.egrey -width 3 -textvariable _gray -state normal -bg white
entry .newimg.f2.egreen -width 3 -textvariable _green -state normal -bg white
entry .newimg.f2.eblue -width 3 -textvariable _blue -state normal -bg white
radiobutton .newimg.f2.r1 -text "Gray" -variable _colo -value 0 -bg lightgrey -anchor nw -width 6 -selectcolor white -command newdisp
radiobutton .newimg.f2.r2 -text "Color" -variable _colo -value 1 -bg lightgrey -anchor nw -width 6 -selectcolor white -command newdisp
update
grid .newimg.f2.lwidth -row 1 -column 1 -padx 2 -pady 2
grid .newimg.f2.ewidth -row 1 -column 2 -padx 2 -pady 2 
grid .newimg.f2.lheight -row 2 -column 1 -padx 2 -pady 2
grid .newimg.f2.eheight -row 2 -column 2 -padx 2 -pady 2 
grid .newimg.f2.lgrey -row 3 -column 1 -padx 2 -pady 2
grid .newimg.f2.egrey -row 3 -column 2 -padx 2 -pady 2 
grid .newimg.f2.egreen -row 3 -column 3 -padx 2 -pady 2 
grid .newimg.f2.eblue -row 3 -column 4 -padx 2 -pady 2 
grid .newimg.f2.r1 -row 4 -column 1 -padx 2 -pady 2 
grid .newimg.f2.r2 -row 4 -column 2 -padx 2 -pady 2 
pack .newimg.f2 -side top -expand yes -fill x

proc newdisp {} {
	global _colo
	if { $_colo == 1 } { 
		.newimg.f2.egreen configure -bg white -state normal
		.newimg.f2.eblue configure -bg white -state normal
	} else {
		.newimg.f2.egreen configure -bg grey -state disabled
		.newimg.f2.eblue configure -bg grey -state disabled
	}		
}
frame .newimg.f -bg lightgrey 
button .newimg.f.ok -text "   OK   " -command nlpcall -relief raised -bd 4 -bg lightgrey
bind .newimg.f.ok <Return> nlpcall 
button .newimg.f.cancel -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command ncancall
bind .newimg.f.cancel <Return> ncancall 
pack .newimg.f.ok .newimg.f.cancel -side left -expand yes -fill both -padx 5 -pady 2
pack .newimg.f -side top -expand yes -fill x
label .newimg.m -bg lightgrey -relief ridge -justify left -bd 3 -textvariable _newimg 
pack .newimg.m -side top -expand yes -fill x


bind .newimg.f2.ewidth   <FocusIn> {
	global _newimg
	set _newimg "Defines the number \nof COLS for new image" 
	update
}
bind .newimg.f2.eheight  <FocusIn> {
	global _newimg
	set _newimg "Defines the number \nof ROWS for new image" 
	update
}
bind .newimg.f2.egrey  <FocusIn> {
	global _newimg
	set _newimg "Defines the grey level\n for the new image" 
	update
}
bind .newimg.f.ok  <FocusIn> {
	global _newimg
	set _newimg "Press here to continue\n " 
	update
}
bind .newimg.f.cancel  <FocusIn> {
	global _newimg
	set _newimg "Press here to quit\n " 
	update
}
bind .newimg.f.ok  <Enter> {
	global _newimg _newimgold
	set _newimgold $_newimg
	set _newimg "Press here to continue\n " 
	update
}
bind .newimg.f.cancel  <Enter> {
	global _newimg _newimgold
	set _newimgold $_newimg
	set _newimg "Press here to quit\n " 
	update
}
bind .newimg.f.cancel  <Leave> {
	global _newimg _newimgold
	set _newimg $_newimgold
	update
}
bind .newimg.f.ok  <Leave> {
	global _newimg _newimgold
	set _newimg $_newimgold
	update
}


proc nlpcall {} {
	global _width _height _gray _status _colo _green _blue
	set _status "Wait process running"
	update idletasks
	if { $_colo == 0 } {
		set fname [newimg -width $_width -height $_height -gray $_gray]
	} else {
		set fname [newimg -width $_width -height $_height -red $_gray -green $_green -blue $_blue]
	}
	set _status "Every operation is performed on current image"
	topopen $fname
	.menu.window add command -label "$fname" -command "rcall $fname"
	ncancall
}
proc ncancall {} {
	pack forget .newimg
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -expand yes -fill y -anchor nw
}
proc newimage {} {
	pack forget .filter
	pack forget .fft
	pack forget .point
	pack forget .ft.toolbar
	pack forget .f3
	pack forget .edit
	pack forget .prefer
	pack forget .color
	focus .newimg.f2.ewidth  
	update idletasks 
	raise .
	pack .newimg -side top -expand yes -padx 2 -pady 2
}



frame .prefer -bg lightgrey -bd 4 -relief ridge
label .prefer.l -text "Preferences" -bg lightgray
pack .prefer.l -side top -expand yes -fill x
frame .prefer.f1 -bg lightgray -bd 3 -relief sunken
label .prefer.f1.lmemfact -text "Memory Factor" -bg lightgrey
entry .prefer.f1.ememfact -width 6 -textvariable _mfactor -bg white -state normal
label .prefer.f1.ldist -text "Distance" -bg lightgrey
entry .prefer.f1.edist -width 6 -textvariable _dist -state normal -bg white
label .prefer.f1.langle -text "Angle" -bg lightgrey
entry .prefer.f1.eangle -width 6 -textvariable _angle -state normal -bg white
grid .prefer.f1.lmemfact -row 1 -column 1 -padx 2  
grid .prefer.f1.ememfact -row 1 -column 2 -padx 2   
grid .prefer.f1.ldist -row 2 -column 1 -padx 2 -pady 2
grid .prefer.f1.edist -row 2 -column 2 -padx 2 -pady 2 
grid .prefer.f1.langle -row 3 -column 1 -padx 2 -pady 2
grid .prefer.f1.eangle -row 3 -column 2 -padx 2 -pady 2
set _dist 5
set _angle 0
set _mfactor 350
pack .prefer.f1 -side top -expand yes -fill x
frame .prefer.f -bg lightgrey 
button .prefer.f.ok -text "   OK   " -command lpcall0 -relief raised -bd 4 -bg lightgrey
bind .prefer.f.ok <Return> lpcall0 
button .prefer.f.cancel -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command cancall0
bind .prefer.f.cancel <Return> cancall0 
pack .prefer.f.ok .prefer.f.cancel -side left -expand yes -fill both -padx 5 -pady 2
pack .prefer.f -side top -expand yes -fill x
label .prefer.m -bg lightgrey -relief ridge -justify left -bd 3 -textvariable _prefer 
pack .prefer.m -side top -expand yes -fill x

bind .prefer.f1.ememfact <FocusIn> {
	global _prefer
	set _prefer "This value defines \nthe size of image \nheld in memory in KB"
	update
}
bind .prefer.f1.edist <FocusIn> {
	global _prefer
	set _prefer "Integer >= 1, specifies \nparameter for texture data\n"
	update
}
bind .prefer.f1.eangle <FocusIn> {
	global _prefer
	set _prefer "Integer >= 0, specifies \nparameter for texture data\n"
	update
}
bind .prefer.f.ok <FocusIn> {
	global _prefer
	set _prefer "Press return to set values\n\n"
	update
}
bind .prefer.f.cancel <FocusIn> {
	global _prefer
	set _prefer "Press return to quit\n\n"
	update
}
bind .prefer.f.ok <Enter> {
	global _prefer _preferold
	set _preferold $_prefer
	set _prefer "Press to set values\n\n"
	update
}
bind .prefer.f.ok <Leave> {
	global _prefer _preferold
	set _prefer $_preferold
	update
}
bind .prefer.f.cancel <Enter> {
	global _prefer _preferold
	set _preferold $_prefer
	set _prefer "Press to quit\n\n"
	update
}
bind .prefer.f.cancel <Leave> {
	global _prefer _preferold
	set _prefer $_preferold
	update
}


proc lpcall0 {} {
	global _mfactor _dist _angle
	if { $_mfactor != "" } {
		setmem $_mfactor
	}
	if {( $_dist != "") && ( $_angle != "") } {
		settex $_dist $_angle
		cancall0
	}
}
proc setprefer {} {
	pack forget .filter
	pack forget .newimg
	pack forget .fft
	pack forget .point
	pack forget .ft.toolbar
	pack forget .f3
	pack forget .edit
	pack forget .color
	focus .prefer.f1.ememfact
	update idletasks 
	raise .
	update idletasks
	pack .prefer -side top -expand yes -padx 2 -pady 2
}
proc cancall0 {} {
	pack forget .prefer
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -expand yes -fill y -anchor nw
}

frame .edit -bg lightgrey -bd 4 -relief ridge
label .edit.l1 -text "selected coordinates" -bg lightgrey
pack .edit.l1 -side top -expand yes -fill x -padx 2 -pady 2
frame .edit.f1 -bg lightgrey -relief sunken -bd 3
label .edit.f1.ltx -text "Top X" -bg lightgrey
entry .edit.f1.etx -textvariable _tx -bg lightgrey -state disabled -width 6
label .edit.f1.lty -text "Top Y" -bg lightgrey
entry .edit.f1.ety -textvariable _ty -bg lightgrey -state disabled -width 6
label .edit.f1.lbx -text "Bottom X" -bg lightgrey
entry .edit.f1.ebx -textvariable _bx -bg lightgrey -state disabled -width 6
label .edit.f1.lby -text "Bottom Y" -bg lightgrey
entry .edit.f1.eby -textvariable _by -bg lightgrey -state disabled -width 6
grid .edit.f1.ltx -row 1 -column 1 -padx 2 -pady 2
grid .edit.f1.etx -row 1 -column 2 -padx 2 -pady 2
grid .edit.f1.lty -row 1 -column 3 -padx 2 -pady 2
grid .edit.f1.ety -row 1 -column 4 -padx 2 -pady 2
grid .edit.f1.lbx -row 2 -column 1 -padx 2 -pady 2
grid .edit.f1.ebx -row 2 -column 2 -padx 2 -pady 2
grid .edit.f1.lby -row 2 -column 3 -padx 2 -pady 2
grid .edit.f1.eby -row 2 -column 4 -padx 2 -pady 2
pack .edit.f1 -side top -expand yes -fill x
label .edit.l2 -text "Paste parameters" -bg lightgrey
pack .edit.l2 -side top -expand yes -fill x -padx 2 -pady 2
frame .edit.f2 -bg lightgrey -bd 3 -relief sunken
label .edit.f2.lpx -text "X Coord" -bg lightgrey
entry .edit.f2.epx -textvariable _px -bg lightgrey -state disabled -width 6
label .edit.f2.lpy -text "Y Coord" -bg lightgrey
entry .edit.f2.epy -textvariable _py -bg lightgrey -state disabled -width 6
entry .edit.f2.efile -textvariable _pfile -bg lightgrey -state disabled -width 13
button .edit.f2.browse -text "Browse" -command {fileDialog . .edit.f2.efile open} -relief raised -bd 4 -bg lightgrey -state disabled
bind .edit.f2.browse <Return> { fileDialog . .edit.f2.efile open }
grid .edit.f2.lpx -row 1 -column 1 -padx 2 -pady 2
grid .edit.f2.epx -row 1 -column 2 -padx 2 -pady 2
grid .edit.f2.lpy -row 1 -column 3 -padx 2 -pady 2
grid .edit.f2.epy -row 1 -column 4 -padx 2 -pady 2
grid .edit.f2.efile -row 2 -column 1 -padx 2 -pady 2 -columnspan 2
grid .edit.f2.browse -row 2 -column 3 -padx 2 -pady 2 -columnspan 2
pack .edit.f2 -side top -expand yes -fill x
frame .edit.f3  -bg lightgrey -relief groove
button .edit.f3.ok  -text "   OK   " -command lpcall4 -relief raised -bd 4 -bg lightgrey
bind .edit.f3.ok  <Return> lpcall4 
button .edit.f3.cancel  -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command cancall4
bind .edit.f3.cancel  <Return> cancall4 
pack .edit.f3.ok  .edit.f3.cancel  -side left -expand yes -fill both -padx 5 -pady 2
pack .edit.f3  -side top -expand yes -fill x -padx 2 -pady 2

label .edit.l3  -textvariable _enter4 -bg lightgrey -relief ridge -bd 3
pack .edit.l3 -side top -fill x -expand yes

bind .edit.f1.etx <FocusIn> {
	global _enter4
	set _enter4 "Top Left X Co-ordinate\n of the Selection"     
	update
}
bind .edit.f1.ety <FocusIn> {
	global _enter4
	set _enter4 "Top Left Y Co-ordinate\n of the Selection"     
	update
}
bind .edit.f1.ebx <FocusIn> {
	global _enter4
	set _enter4 "Bottom Right X Co-ordinate\n of the Selection"     
	update
}
bind .edit.f1.eby <FocusIn> {
	global _enter4
	set _enter4 "Bottom Right Y Co-ordinate\n of the Selection"     
	update
}
bind .edit.f2.epx <FocusIn> {
	global _enter4
	set _enter4 "Top Left X Co-ordinate\n of the Pasting"     
	update
}
bind .edit.f2.epy <FocusIn> {
	global _enter4
	set _enter4 "Top Left Y Co-ordinate\n of the Pasting"     
	update
}
bind .edit.f2.efile <FocusIn> {
	global _enter4
	set _enter4 "Enter the name\n of the file to Paste"     
	update
}
bind .edit.f2.browse <FocusIn> {
	global _enter4
	set _enter4 "Press <Return> to Browse\n"     
	update
}
bind .edit.f2.browse  <Enter> {
	global _enter4 _enter4old
	set _enter4old $_enter4
	set _enter4 "Click to Browse\n " 
	update
}
bind .edit.f2.browse <Leave> {
	global _enter4 _enter4old
	set _enter4 $_enter4old
	update
} 
bind .edit.f3.ok  <FocusIn> {
	global _enter4
	set _enter4 "Press <Return> to continue\n " 
	update
}
bind .edit.f3.cancel  <FocusIn> {
	global _enter4
	set _enter4 "Press <Return> to quit\n " 
	update
}
bind .edit.f3.ok  <Enter> {
	global _enter4 _enter4old
	set _enter4old $_enter4
	set _enter4 "Click to continue\n " 
	update
}
bind .edit.f3.cancel  <Enter> {
	global _enter4 _enter4old
	set _enter4old $_enter4
	set _enter4 "Click to quit\n " 
	update
}
bind .edit.f3.ok <Leave> {
	global _enter4 _enter4old
	set _enter4 $_enter4old
	update
} 
bind .edit.f3.cancel <Leave> {
	global _enter4 _enter4old
	set _enter4 $_enter4old
	update
} 




image create photo new1 -file new.gif
image create photo open1 -file open.gif
image create photo save1 -file floppy.gif
image create photo edge1 -file edge.gif
image create photo neg1 -file neg.gif
image create photo double1 -file double1.gif
image create photo mirror1 -file mirror.gif
image create photo trans1 -file tran1.gif
image create photo equa1 -file equa.gif
image create photo fft1 -file fft.gif
image create photo view1 -file full.gif
image create photo exit1 -file exit.gif
frame .ft -bg lightgrey
frame .ft.toolbar -relief groove -bg lightgrey -bd 3
button .ft.toolbar.new  -command newimage -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image new1 
button .ft.toolbar.open  -command imgopen -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image open1 
button .ft.toolbar.save  -command imgsave  -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image  save1
button .ft.toolbar.neg  -command "singleopr neg" -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image neg1 
button .ft.toolbar.double  -command "singleopr double" -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image double1  
button .ft.toolbar.mirror  -command "singleopr hflip" -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image  mirror1
button .ft.toolbar.trans  -command "singleopr transpose" -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image  trans1
button .ft.toolbar.equa  -command "singleopr equalise" -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image  equa1
button .ft.toolbar.fft  -command "singleopr fft" -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image  fft1
button .ft.toolbar.edge  -command "singleopr sobel" -relief raised -bd 2 -bg lightgrey -width 25 -height 25 -image edge1 
button .ft.toolbar.view   -relief raised -bd 2 -bg lightgrey -command zoom  -width 25 -height 25 -image view1 
button .ft.toolbar.exit  -command confirmdw -relief raised -bd 2 -bg lightgrey  -width 25 -height 25 -image exit1
pack .ft.toolbar.new .ft.toolbar.open .ft.toolbar.save .ft.toolbar.neg .ft.toolbar.double .ft.toolbar.mirror .ft.toolbar.trans .ft.toolbar.view .ft.toolbar.fft .ft.toolbar.edge .ft.toolbar.equa .ft.toolbar.exit -side left -padx 2 -pady 1 

frame .ft.f1 -relief ridge -bg lightgrey -bd 4
label .ft.f1.l1 -text "The current file is" -bg lightgrey -anchor nw
label .ft.f1.l2 -textvariable _current1 -bg lightgrey
pack .ft.f1.l1 .ft.f1.l2 -side left -padx 5
pack .ft.toolbar -side top -expand yes -fill x -anchor nw
pack .ft.f1 -side bottom -expand yes -fill x -anchor nw
pack .ft -side top -fill x -expand yes -anchor nw
balloonhelp_for .ft.toolbar.new { create new image }
balloonhelp_for .ft.toolbar.open { open an image }
balloonhelp_for .ft.toolbar.save { save current image as }
balloonhelp_for .ft.toolbar.neg { negation }
balloonhelp_for .ft.toolbar.double { double }
balloonhelp_for .ft.toolbar.mirror { horizontal flip }
balloonhelp_for .ft.toolbar.trans { transpose }
balloonhelp_for .ft.toolbar.equa { equalise }
balloonhelp_for .ft.toolbar.fft { frequency response }
balloonhelp_for .ft.toolbar.edge { edge detection }
balloonhelp_for .ft.toolbar.view { full view }
balloonhelp_for .ft.toolbar.exit { exit IPGUI }

frame .f2 -relief ridge -bg lightgrey -bd 4
label .f2.l -textvariable _status -bg lightgrey
pack .f2.l -side left
pack .f2 -side bottom -expand yes -fill x -anchor se
set _status "Every operation is performed on current image"
update

frame .f3 -relief ridge -bg lightgrey -bd 3 -width 25 -height 370
label .f3.l1 -text "Operation Mode" -bg lightgrey
pack .f3.l1 -side top -fill x -expand yes -padx 2 -pady 2
frame .f3.f1 -relief sunken -bg lightgrey -bd 2
radiobutton .f3.f1.r1 -text "Default" -variable _user -value 0 -bg lightgrey -anchor nw -width 15 -selectcolor white 
radiobutton .f3.f1.r2 -text "User defined" -variable _user -value 1 -bg lightgrey -anchor nw -width 15 -selectcolor white
pack .f3.f1.r1 .f3.f1.r2 -side top -padx 2 -pady 2 -expand yes -fill x
pack .f3.f1 -side top -fill x -expand yes -padx 2 -pady 2

label .f3.l4 -text "Balloon Help" -bg lightgrey
pack .f3.l4 -side top -fill x -expand yes -padx 2 -pady 2
frame .f3.f4 -relief sunken -bg lightgrey -bd 2
radiobutton .f3.f4.r1 -text "ON" -variable _show -value 1 -bg lightgrey -anchor nw -width 15 -selectcolor white 
radiobutton .f3.f4.r2 -text "OFF" -variable _show -value 0 -bg lightgrey -anchor nw -width 15 -selectcolor white
pack .f3.f4.r1 .f3.f4.r2 -side top -padx 2 -pady 2 -expand yes -fill x
pack .f3.f4 -side top -fill x -expand yes -padx 2 -pady 2
pack .f3 -side left -anchor nw -expand yes -fill y

label .f3.l2 -text "Morphology type" -bg lightgrey
pack .f3.l2 -side top -fill x -expand yes -padx 2 -pady 2
frame .f3.f2 -relief sunken -bg lightgrey -bd 2
radiobutton .f3.f2.r1 -text "Binary" -variable _type -value 0 -bg lightgrey -anchor nw -width 15 -selectcolor white
radiobutton .f3.f2.r2 -text "Grey level" -variable _type -value 1 -bg lightgrey -anchor nw -width 15 -selectcolor white
pack .f3.f2.r1 .f3.f2.r2 -side top -padx 2 -pady 2 -expand yes -fill x
pack .f3.f2 -side top -fill x -expand yes -padx 2 -pady 2
label .f3.l3 -text "Filter type" -bg lightgrey
pack .f3.l3 -side top -fill x -expand yes -padx 2 -pady 2
frame .f3.f3 -relief sunken -bg lightgrey -bd 2
radiobutton .f3.f3.r1 -text "FFT filters" -variable _filter -value 0 -bg lightgrey -anchor nw -width 15 -selectcolor white
radiobutton .f3.f3.r2 -text "FIR filters" -variable _filter -value 1 -bg lightgrey -anchor nw -width 15 -selectcolor white
radiobutton .f3.f3.r3 -text "IIR filters" -variable _filter -value 2 -bg lightgrey -anchor nw -width 15 -selectcolor white
pack .f3.f3.r1 .f3.f3.r2 .f3.f3.r3 -side top -padx 2 -pady 2 -expand yes -fill x
pack .f3.f3 -side top -fill x -expand yes -padx 2 -pady 2

label .f3.l5 -text "Color Model" -bg lightgrey
pack .f3.l5 -side top -fill x -expand yes -padx 2 -pady 2
frame .f3.f5 -relief sunken -bg lightgrey -bd 2
frame .f3.f5.left
frame .f3.f5.right
radiobutton .f3.f5.r1 -text "RGB" -variable _model -value "RGB" -bg lightgrey -anchor nw -width 5 -selectcolor white -command dispmodel
radiobutton .f3.f5.r2 -text "HSV" -variable _model -value "HSV" -bg lightgrey -anchor nw -width 5 -selectcolor white -command dispmodel
radiobutton .f3.f5.r3 -text "XYZ" -variable _model -value "XYZ" -bg lightgrey -anchor nw -width 5 -selectcolor white -command dispmodel
radiobutton .f3.f5.r4 -text "YIQ" -variable _model -value "YIQ" -bg lightgrey -anchor nw -width 5 -selectcolor white -command dispmodel
pack .f3.f5.left -side left
pack .f3.f5.right -side right
pack .f3.f5.r1 .f3.f5.r2 -in .f3.f5.left -side top  -padx 1 -pady 1 -expand yes -fill x
pack .f3.f5.r3 .f3.f5.r4 -in .f3.f5.right -side top  -padx 1 -pady 1 -expand yes -fill x
pack .f3.f5 -side top -fill x -expand yes -padx 2 -pady 2

label .f3.l6 -text "Flags" -bg lightgrey
pack .f3.l6 -side top -fill x -expand yes -padx 2 -pady 2
frame .f3.f6 -relief sunken -bg lightgrey -bd 2
checkbutton .f3.f6.r1 -text "RED" -variable _i -bg lightgrey -anchor nw -width 15 -selectcolor white
checkbutton .f3.f6.r2 -text "GREEN" -variable _j -bg lightgrey -anchor nw -width 15 -selectcolor white
checkbutton .f3.f6.r3 -text "BLUE" -variable _k -bg lightgrey -anchor nw -width 15 -selectcolor white
pack .f3.f6.r1 .f3.f6.r2 .f3.f6.r3 -side top -padx 2 -pady 2 -expand yes -fill x
pack .f3.f6 -side top -fill x -expand yes -padx 2 -pady 2

pack forget .f3.l2
pack forget .f3.f2
pack forget .f3.l3
pack forget .f3.f3
pack forget .f3.l5
pack forget .f3.f5
pack forget .f3.l6
pack forget .f3.f6

frame .point -bg lightgrey -relief ridge -width 100 -height 250 -bd 5

frame .point.f -bg lightgrey -relief groove -bd 3
label .point.f.l1 -text "OPERATION :" -bg lightgrey
label .point.f.l2 -textvariable _operation -bg lightgrey
pack .point.f.l1 .point.f.l2 -side left -padx 5 -pady 2 -fill x -expand yes
pack .point.f -side top -expand yes -fill x -padx 2 -pady 2

label .point.l -text "Enter the following values" -bg lightgrey
pack .point.l -side top -expand yes -fill x -padx 2 

frame .point.f1 -bg lightgrey -relief sunken -bd 3
label .point.f1.lllimit -text "Lower Limit" -bg lightgrey
entry .point.f1.ellimit -width 6 -textvariable _llimit -state disabled -bg lightgrey
label .point.f1.lulimit -text "Upper Limit" -bg lightgrey
entry .point.f1.eulimit -width 6 -textvariable _ulimit -state disabled -bg lightgrey
label .point.f1.liter -text "Iterations" -bg lightgrey
entry .point.f1.eiter -width 6 -textvariable _iter -state disabled -bg lightgrey
label .point.f1.lbps -text "Bit Number" -bg lightgrey
entry .point.f1.ebps -width 6 -textvariable _bpval -state disabled -bg lightgrey
grid .point.f1.lllimit -row 1 -column 1 -padx 2 -pady 2
grid .point.f1.ellimit -row 1 -column 2 -padx 2 -pady 2
grid .point.f1.lulimit -row 1 -column 3 -padx 2 -pady 2
grid .point.f1.eulimit -row 1 -column 4 -padx 2 -pady 2
grid .point.f1.liter -row 2 -column 1 -padx 2 -pady 2
grid .point.f1.eiter -row 2 -column 2 -padx 2 -pady 2
grid .point.f1.lbps -row 2 -column 3 -padx 2 -pady 2
grid .point.f1.ebps -row 2 -column 4 -padx 2 -pady 2
pack .point.f1 -side top -fill x -expand yes -padx 2 -pady 2
frame .point.f2 -bg lightgrey -relief groove -bd 3
label .point.f2.l -text "Thresholding Operation" -bg lightgrey
label .point.f2.lthr -text "Threshold" -bg lightgrey
entry .point.f2.ethr -width 5 -textvariable _thr -state disabled -bg lightgrey
entry .point.f2.ethrg -width 5 -textvariable _thrg -state disabled -bg lightgrey
entry .point.f2.ethrb -width 5 -textvariable _thrb -state disabled -bg lightgrey

global percen
set percen 0
radiobutton .point.f2.gray -text "Gray level" -value 0 -variable percen -bg lightgrey -width 15 -anchor nw  -state disabled
radiobutton .point.f2.per -text "Percentile" -value 1 -variable percen -bg lightgrey -width 15 -anchor nw  -state disabled
grid .point.f2.l -row 1 -column 1 -padx 2 -columnspan 2 
grid .point.f2.lthr -row 2 -column 1 -padx 2 -pady 2 
grid .point.f2.ethr -row 2 -column 2 -padx 2 -pady 2
grid .point.f2.ethrg -row 2 -column 3 -padx 2 -pady 2
grid .point.f2.ethrb -row 2 -column 4 -padx 2 -pady 2
grid .point.f2.gray -row 3 -column 1 -padx 2 -pady 2 -sticky nw
grid .point.f2.per -row 3 -column 2 -padx 2 -pady 2 -sticky nw
pack .point.f2 -side top -fill x -expand yes -padx 2 -pady 2

frame .point.f3 -bg lightgrey -relief sunken -bd 3
label .point.f3.l -text "Select Second File" -bg lightgrey
entry .point.f3.efile -width 15 -textvariable _sfile -state disabled -bg lightgrey
button .point.f3.browse -text " BROWSE " -command {fileDialog . .point.f3.efile open}  -relief raised -bd 4 -bg lightgrey -state disabled
bind .point.f3.browse <Return> { fileDialog . .point.f3.efile open }
radiobutton .point.f3.avg -text  "Average" -variable _super -value 0 -bg lightgrey -width 15 -anchor nw -state disabled
radiobutton .point.f3.max -text  "Maximum" -variable _super -value 1 -bg lightgrey -width 15 -anchor nw -state disabled
set _super 0
grid .point.f3.l -row 1 -column 1 -padx 2 -columnspan 2 
grid .point.f3.efile -row 2 -column 1 -padx 2 
grid .point.f3.browse -row 2 -column 2 -padx 2
grid .point.f3.avg -row 3 -column 1 -padx 2 -pady 2 -sticky nw
grid .point.f3.max -row 3 -column 2 -padx 2 -pady 2 -sticky nw
pack .point.f3 -side top -fill x -expand yes -padx 2 -pady 2

frame .point.f4 -bg lightgrey -relief groove
button .point.f4.ok -text "   OK   " -command lpcall3 -relief raised -bd 4 -bg lightgrey
bind .point.f4.ok <Return> lpcall3 
button .point.f4.cancel -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command cancall3
bind .point.f4.cancel <Return> cancall3 
pack .point.f4.ok .point.f4.cancel -side left -expand yes -fill both -padx 5 -pady 2
pack .point.f4 -side top -expand yes -fill x -padx 2 -pady 2

label .point.l2 -textvariable _enter1 -bg lightgrey -relief ridge -bd 3
pack .point.l2 -side left -fill x -expand yes

bind .point.f1.ellimit <FocusIn> {
	global _enter1
	set _enter1 "Lower limit > 0 < upper limit"
	update idletasks
}
bind .point.f1.eulimit <FocusIn> {
	global _enter1
	set _enter1 "Upper limit < 255 > Lower limit"
	update idletasks
}
bind .point.f1.eiter <FocusIn> {
	global _enter1
	set _enter1 "Number of iterations"
	update idletasks
}
bind .point.f1.ebps <FocusIn> {
	global _enter1
	set _enter1 "Bit plane number"
	update idletasks
}
bind .point.f2.ethr <FocusIn> {
	global _enter1
	set _enter1 "Threshold value"
	update idletasks
}
bind .point.f2.gray <FocusIn> {
	global _enter1
	set _enter1 "Threshold is gray level"
	update idletasks
}
bind .point.f2.per <FocusIn> {
	global _enter1
	set _enter1 "Threshold is percentile"
	update idletasks
}
bind .point.f3.efile <FocusIn> {
	global _enter1
	set _enter1 "Name of file"
	update idletasks
}
bind .point.f3.browse <FocusIn> {
	global _enter1
	set _enter1 "Press to get  filebox"
	update
}
bind .point.f3.avg <FocusIn> {
	global _enter1
	set _enter1 "Select averaging operation"
	update
}
bind .point.f3.max <FocusIn> {
	global _enter1
	set _enter1 "Select superimpose operation"
	update
}
bind .point.f4.ok <FocusIn> {
	global _enter1
	set _enter1 "Press enter to process"
	update
}
bind .point.f4.cancel <FocusIn> {
	global _enter1
	set _enter1 "press enter to cancel"
	update
}
bind .point.f2.gray <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "Threshold is gray level"
	update
}
bind .point.f2.gray <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 
bind .point.f2.per <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "Threshold is percentile"
	update
}
bind .point.f2.per <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 
bind .point.f3.browse <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "File to use"
	update
}
bind .point.f3.browse <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 
bind .point.f3.avg <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "Select averaging operation"
	update
}
bind .point.f3.avg <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 
bind .point.f3.max <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "Select superimpose operation"
	update
}
bind .point.f3.max <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 
bind .point.f4.ok <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "Press to process"
	update
}
bind .point.f4.ok <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 
bind .point.f4.cancel <Enter> {
	global _enter1 _enter1old
	set _enter1old $_enter1
	set _enter1 "Press to cancel"
	update
}
bind .point.f4.cancel <Leave> {
	global _enter1 _enter1old
	set _enter1 $_enter1old
	update
} 


frame .filter -bg lightgrey -relief ridge -width 100 -height 250 -bd 5

frame .filter.f -bg lightgrey -relief groove -bd 3
label .filter.f.l1 -text "OPERATION :" -bg lightgrey
label .filter.f.l2 -textvariable _operation -bg lightgrey
pack .filter.f -side top -expand yes -fill x -padx 2 -pady 2
pack .filter.f.l1 .filter.f.l2 -side left -padx 5 -pady 2 -fill x -expand yes

label .filter.l -text "Enter the following values" -bg lightgrey
pack .filter.l -side top -expand yes -fill x -padx 2 -pady 2

frame .filter.f1 -bg lightgrey -relief sunken -bd 3
label .filter.f1.lrows -text "Mask rows" -bg lightgrey
entry .filter.f1.erows -width 6 -textvariable _rows -state disabled -bg lightgrey
label .filter.f1.lcols -text "Mask cols" -bg lightgrey
entry .filter.f1.ecols -width 6 -textvariable _cols -state disabled -bg lightgrey
label .filter.f1.lorgx -text "Origin X" -bg lightgrey
entry .filter.f1.eorgx -width 6 -textvariable _orgx -state disabled -bg lightgrey
label .filter.f1.lorgy -text "Origin Y" -bg lightgrey
entry .filter.f1.eorgy -width 6 -textvariable _orgy -state disabled -bg lightgrey
label .filter.f1.lamp -text "Amplification" -bg lightgrey
entry .filter.f1.eamp -width 6 -textvariable _amp -state disabled -bg lightgrey
label .filter.f1.lfac -text "Factor" -bg lightgrey
entry .filter.f1.efac -width 6 -textvariable _fac -state disabled -bg lightgrey
label .filter.f1.lsig -text "Sigma" -bg lightgrey
entry .filter.f1.esig -width 6 -textvariable _sig -state disabled -bg lightgrey
label .filter.f1.lstddev -text "std dev" -bg lightgrey
entry .filter.f1.estddev -width 6 -textvariable _stddev -state disabled -bg lightgrey
label .filter.f1.llow -text "Lower limit" -bg lightgrey
entry .filter.f1.elow -width 6 -textvariable _low -state disabled -bg lightgrey
label .filter.f1.lhigh -text "Upper limit" -bg lightgrey
entry .filter.f1.ehigh -width 6 -textvariable _high -state disabled -bg lightgrey
grid .filter.f1.lrows -row 1 -column 1 -padx 2 -pady 2
grid .filter.f1.erows -row 1 -column 2 -padx 2 -pady 2
grid .filter.f1.lcols -row 1 -column 3 -padx 2 -pady 2
grid .filter.f1.ecols -row 1 -column 4 -padx 2 -pady 2
grid .filter.f1.lorgx -row 2 -column 1 -padx 2 -pady 2
grid .filter.f1.eorgx -row 2 -column 2 -padx 2 -pady 2
grid .filter.f1.lorgy -row 2 -column 3 -padx 2 -pady 2
grid .filter.f1.eorgy -row 2 -column 4 -padx 2 -pady 2
grid .filter.f1.lsig -row 3 -column 1 -padx 2 -pady 2
grid .filter.f1.esig -row 3 -column 2 -padx 2 -pady 2
grid .filter.f1.lfac -row 3 -column 3 -padx 2 -pady 2
grid .filter.f1.efac -row 3 -column 4 -padx 2 -pady 2
grid .filter.f1.lamp -row 4 -column 1 -padx 2 -pady 2 
grid .filter.f1.eamp -row 4 -column 2 -padx 2 -pady 2
grid .filter.f1.lstddev -row 4 -column 3 -padx 2 -pady 2
grid .filter.f1.estddev -row 4 -column 4 -padx 2 -pady 2
grid .filter.f1.llow -row 5 -column 1 -padx 2 -pady 2
grid .filter.f1.elow -row 5 -column 2 -padx 2 -pady 2
grid .filter.f1.lhigh -row 5 -column 3 -padx 2 -pady 2
grid .filter.f1.ehigh -row 5 -column 4 -padx 2 -pady 2
pack .filter.f1 -side top -expand yes -fill x -padx 2 -pady 2
label .filter.l2 -text "Enter mask values in Row major order" -bg lightgrey
pack .filter.l2 -side top -expand yes -fill x -padx 2 -pady 2
text .filter.t1 -height 3 -width 40 -state disabled -bg lightgrey
pack .filter.t1 -side top -expand yes -fill x -padx 2 -pady 2
frame .filter.f3 -bg lightgrey -relief groove
button .filter.f3.ok -text "   OK   " -command lpcall1 -relief raised -bd 4 -bg lightgrey 
button .filter.f3.cancel -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command cancall1 
pack .filter.f3.ok .filter.f3.cancel -side left -expand yes -fill both -padx 5 -pady 5
pack .filter.f3 -side top -expand yes -fill x -padx 2 -pady 2
label .filter.l3 -textvariable _enter -bg lightgrey -bd 3 -relief ridge
pack .filter.l3 -side top -expand yes -fill x -padx 2 -pady 2 
set _enter "Press OK to process"
bind .filter.t1 <Control-z> { focus .filter.f3.ok }
bind .filter.f3.ok <Return> lpcall1 
bind .filter.f3.cancel <Return> cancall1

bind .filter.f1.erows <FocusIn> {
	global _enter
	set _enter "mask rows"
	update
}
bind .filter.f1.ecols <FocusIn> {
	global _enter
	set _enter "mask columns"
	update
}
bind .filter.f1.eorgx <FocusIn> {
	global _enter
	set _enter "X coordinate of origin < mask rows"
	update
}
bind .filter.f1.eorgy <FocusIn> {
	global _enter
	set _enter "Y coordinate of origin < mask cols"
	update
}
bind .filter.f1.esig <FocusIn> {
	global _enter
	set _enter "integer >= 1"
	update
}
bind .filter.f1.eamp <FocusIn> {
	global _enter
	set _enter "Amplification > 1"
	update
}
bind .filter.f1.estddev <FocusIn> {
	global _enter
	set _enter "number >= 1.0"
	update
}
bind .filter.f1.efac <FocusIn> {
	global _enter
	set _enter "Number > 0 "
	update
}
bind .filter.t1 <FocusIn> {
	global _enter
	set _enter "Press Control-z after entering values"
	update
}
bind .filter.f3.ok <FocusIn> {
	global _enter
	set _enter "Press to process"
	update
}
bind .filter.f3.cancel <FocusIn> {
	global _enter
	set _enter "Press to cancel operation"
}
bind .filter.f3.ok <Enter> {
	global _enter _enterold
	set _enterold $_enter
	set _enter "Press to process"
	update
}
bind .filter.f3.ok <Leave> {
	global _enter _enterold
	set _enter $_enterold
	update
}
bind .filter.f3.cancel <Enter> {
	global _enter _enterold
	set _enterold $_enter
	set _enter "Press to cancel operation"
	update
}
bind .filter.f3.cancel <Leave> {
	global _enter _enterold
	set _enter $_enterold
	update
}


frame .color -bg lightgrey -relief ridge -width 100 -height 250 -bd 5

frame .color.f -bg lightgrey -relief groove -bd 3
label .color.f.l1 -text "OPERATION :" -bg lightgrey
label .color.f.l2 -textvariable _operation -bg lightgrey
pack .color.f -side top -expand yes -fill x -padx 2 -pady 2
pack .color.f.l1 .color.f.l2 -side left -padx 5 -pady 2 -fill x -expand yes

label .color.l -text "Enter the following values" -bg lightgrey
pack .color.l -side top -expand yes -fill x -padx 2 -pady 2

frame .color.f1 -bg lightgrey -relief sunken -bd 3
label .color.f1.lred -text "RED" -bg lightgrey
entry .color.f1.ered -width 6 -textvariable _ival -state disabled -bg lightgrey
label .color.f1.lrbw -text "R Bandwidth" -bg lightgrey
entry .color.f1.erbw -width 6 -textvariable _ibw -state disabled -bg lightgrey
label .color.f1.lgreen -text "GREEN" -bg lightgrey
entry .color.f1.egreen -width 6 -textvariable _jval -state disabled -bg lightgrey
label .color.f1.lgbw -text "G Bandwidth" -bg lightgrey
entry .color.f1.egbw -width 6 -textvariable _jbw -state disabled -bg lightgrey
label .color.f1.lblue -text "BLUE" -bg lightgrey
entry .color.f1.eblue -width 6 -textvariable _kval -state disabled -bg lightgrey
label .color.f1.lbbw -text "B Bandwidth" -bg lightgrey
entry .color.f1.ebbw -width 6 -textvariable _kbw -state disabled -bg lightgrey
label .color.f1.lnm -text "NM Value" -bg lightgrey
entry .color.f1.enm -width 6 -textvariable _nm -state disabled -bg lightgrey
label .color.f1.lnmbw -text "NM Bandwidth" -bg lightgrey
entry .color.f1.enmbw -width 6 -textvariable _nmbw -state disabled -bg lightgrey
label .color.f1.lorder -text "Order" -bg lightgrey
entry .color.f1.eorder -width 6 -textvariable _ord -state disabled -bg lightgrey
label .color.f1.lbox -text "No.of boxes" -bg lightgrey
entry .color.f1.ebox -width 6 -textvariable _box -state disabled -bg lightgrey
label .color.f1.llevels -text "Levels" -bg lightgrey
entry .color.f1.elevels -width 6 -textvariable _levels -state disabled -bg lightgrey
label .color.f1.lcolors -text "No.of colors" -bg lightgrey
entry .color.f1.ecolors -width 6 -textvariable _color -state disabled -bg lightgrey

label .color.f1.lper -text "Percentage" -bg lightgrey
entry .color.f1.eper -width 6 -textvariable _per -state disabled -bg lightgrey
label .color.f1.lpoles -text "No.of poles" -bg lightgrey
entry .color.f1.epoles -width 6 -textvariable _poles -state disabled -bg lightgrey
grid .color.f1.lred -row 1 -column 1 -padx 2 -pady 2
grid .color.f1.ered -row 1 -column 2 -padx 2 -pady 2
grid .color.f1.lrbw -row 1 -column 3 -padx 2 -pady 2
grid .color.f1.erbw -row 1 -column 4 -padx 2 -pady 2
grid .color.f1.lgreen -row 2 -column 1 -padx 2 -pady 2
grid .color.f1.egreen -row 2 -column 2 -padx 2 -pady 2
grid .color.f1.lgbw -row 2 -column 3 -padx 2 -pady 2
grid .color.f1.egbw -row 2 -column 4 -padx 2 -pady 2
grid .color.f1.lblue -row 3 -column 1 -padx 2 -pady 2
grid .color.f1.eblue -row 3 -column 2 -padx 2 -pady 2
grid .color.f1.lbbw -row 3 -column 3 -padx 2 -pady 2
grid .color.f1.ebbw -row 3 -column 4 -padx 2 -pady 2
grid .color.f1.lnm -row 4 -column 1 -padx 2 -pady 2 
grid .color.f1.enm -row 4 -column 2 -padx 2 -pady 2
grid .color.f1.lnmbw -row 4 -column 3 -padx 2 -pady 2
grid .color.f1.enmbw -row 4 -column 4 -padx 2 -pady 2
grid .color.f1.lorder -row 5 -column 1 -padx 2 -pady 2
grid .color.f1.eorder -row 5 -column 2 -padx 2 -pady 2
grid .color.f1.lbox -row 5 -column 3 -padx 2 -pady 2
grid .color.f1.ebox -row 5 -column 4 -padx 2 -pady 2
grid .color.f1.llevels -row 6 -column 1 -padx 2 -pady 2
grid .color.f1.elevels -row 6 -column 2 -padx 2 -pady 2
grid .color.f1.lcolors -row 6 -column 3 -padx 2 -pady 2
grid .color.f1.ecolors -row 6 -column 4 -padx 2 -pady 2
grid .color.f1.lper -row 7 -column 1 -padx 2 -pady 2
grid .color.f1.eper -row 7 -column 2 -padx 2 -pady 2
grid .color.f1.lpoles -row 7 -column 3 -padx 2 -pady 2
grid .color.f1.epoles -row 7 -column 4 -padx 2 -pady 2

pack .color.f1 -side top -expand yes -fill x -padx 2 -pady 2
label .color.l2 -text "Enter hue values" -bg lightgrey
pack .color.l2 -side top -expand yes -fill x -padx 2 -pady 2
text .color.t1 -height 1 -width 40 -state disabled -bg lightgrey
pack .color.t1 -side top -expand yes -fill x -padx 2 -pady 2
frame .color.f3 -bg lightgrey -relief groove
button .color.f3.ok -text "   OK   " -command colorcall -relief raised -bd 4 -bg lightgrey 
button .color.f3.cancel -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command cancall9 
pack .color.f3.ok .color.f3.cancel -side left -expand yes -fill both -padx 5 -pady 5
pack .color.f3 -side top -expand yes -fill x -padx 2 -pady 2
label .color.l3 -textvariable _enter -bg lightgrey -bd 3 -relief ridge
pack .color.l3 -side top -expand yes -fill x -padx 2 -pady 2 
set _enter "Press OK to process"
bind .color.t1 <Control-z> { focus .color.f3.ok }
bind .color.f3.ok <Return> lpcall1 
bind .color.f3.cancel <Return> cancall1

bind .color.f1.ered <FocusIn> {
	global _enter
	set _enter "Red value"
	update
}
bind .color.f1.erbw <FocusIn> {
	global _enter
	set _enter "Red Bandwidth"
	update
}
bind .color.f1.egreen <FocusIn> {
	global _enter
	set _enter "Green Value"
	update
}
bind .color.f1.egbw <FocusIn> {
	global _enter
	set _enter "Green Bandwidth"
	update
}
bind .color.f1.eblue <FocusIn> {
	global _enter
	set _enter "Blue Value"
	update
}
bind .color.f1.ebbw <FocusIn> {
	global _enter
	set _enter "Blue Bandwidth"
	update
}
bind .color.f1.enm <FocusIn> {
	global _enter
	set _enter "Nano-meter value"
	update
}
bind .color.f1.enmbw <FocusIn> {
	global _enter
	set _enter "Nano-meter bandwidth"
	update
}
bind .color.f1.eorder <FocusIn> {
	global _enter
	set _enter "Order Value"
	update
}
bind .color.f1.ebox <FocusIn> {
	global _enter
	set _enter "Desired no.of boxes"
	update
}
bind .color.f1.elevels <FocusIn> {
	global _enter
	set _enter "No.of Levels"
	update
}
bind .color.f1.ecolors <FocusIn> {
	global _enter
	set _enter "Desired no.of colors"
	update
}
bind .color.f1.eper <FocusIn> {
	global _enter
	set _enter "Percentage Value"
	update
}
bind .color.f1.epoles <FocusIn> {
	global _enter
	set _enter "No.of poles in Hue Histogram"
	update
}
bind .color.t1 <FocusIn> {
	global _enter
	set _enter "Press Control-z after entering values"
	update
}
bind .color.f3.ok <FocusIn> {
	global _enter
	set _enter "Press to process"
	update
}
bind .color.f3.cancel <FocusIn> {
	global _enter
	set _enter "Press to cancel operation"
}
bind .color.f3.ok <Enter> {
	global _enter _enterold
	set _enterold $_enter
	set _enter "Press to process"
	update
}
bind .color.f3.ok <Leave> {
	global _enter _enterold
	set _enter $_enterold
	update
}
bind .color.f3.cancel <Enter> {
	global _enter _enterold
	set _enterold $_enter
	set _enter "Press to cancel operation"
	update
}
bind .color.f3.cancel <Leave> {
	global _enter _enterold
	set _enter $_enterold
	update
}



frame .fft -bg lightgrey -bd 5 -relief ridge -width 200 -height 300
frame .fft.f1 -bg lightgrey -bd 3 -relief groove
label .fft.f1.l1 -text "Filter Class" -bg lightgrey -anchor nw
label .fft.f1.l2 -textvariable _filclas -bg lightgrey
pack .fft.f1.l1 .fft.f1.l2 -side left -padx 2 -pady 2 -expand yes -fill x
pack .fft.f1 -side top -expand yes -fill x
frame .fft.f2 -bg lightgrey -bd 3 -relief groove
label .fft.f2.l1 -text "Filter Type" -bg lightgrey -anchor nw
label .fft.f2.l2 -textvariable _filtype -bg lightgrey
pack .fft.f2.l1 .fft.f2.l2 -side left -padx 2 -pady 2 -expand yes -fill x
pack .fft.f2 -side top -expand yes -fill x
label .fft.l1 -text "Enter the following values" -bg lightgrey
pack .fft.l1 -side top -padx 2 -pady 2 -expand yes -fill x

frame .fft.f3 -bg lightgrey -relief sunken -bd 4
label .fft.f3.lcf -text "Cutoff frequency" -bg lightgrey
entry .fft.f3.ecf -width 6 -textvariable _cf -state disabled -bg lightgrey
label .fft.f3.lcf1 -text "Lower cutoff" -bg lightgrey
entry .fft.f3.ecf1 -width 6 -textvariable _cf1 -state disabled -bg lightgrey
label .fft.f3.lcf2 -text "Upper cutoff" -bg lightgrey
entry .fft.f3.ecf2 -width 6 -textvariable _cf2 -state disabled -bg lightgrey
label .fft.f3.lirs -text "Impulse response size" -bg lightgrey
entry .fft.f3.eirs -width 6 -textvariable _irs -state disabled -bg lightgrey
label .fft.f3.lms -text "Mask size" -bg lightgrey
entry .fft.f3.ems -width 6 -textvariable _ms -state disabled -bg lightgrey
label .fft.f3.lord -text "Order of the filter" -bg lightgrey
entry .fft.f3.eord -width 6 -textvariable _ord -state disabled -bg lightgrey
grid .fft.f3.lcf -row 1 -column 1 -padx 2 -pady 2
grid .fft.f3.ecf -row 1 -column 2 -padx 2 -pady 2
grid .fft.f3.lcf1 -row 2 -column 1 -padx 2 -pady 2
grid .fft.f3.ecf1 -row 2 -column 2 -padx 2 -pady 2
grid .fft.f3.lcf2 -row 3 -column 1 -padx 2 -pady 2
grid .fft.f3.ecf2 -row 3 -column 2 -padx 2 -pady 2
grid .fft.f3.lirs -row 1 -column 3 -padx 2 -pady 2
grid .fft.f3.eirs -row 1 -column 4 -padx 2 -pady 2
grid .fft.f3.lms -row 2 -column 3 -padx 2 -pady 2
grid .fft.f3.ems -row 2 -column 4 -padx 2 -pady 2
grid .fft.f3.lord -row 3 -column 3 -padx 2 -pady 2
grid .fft.f3.eord -row 3 -column 4 -padx 2 -pady 2
pack .fft.f3 -side top -expand yes -fill x -padx 2 -pady 2
frame .fft.f4 -bg lightgrey -relief groove -bd 4
label .fft.f4.l1 -text "Select the window function" -bg lightgrey -padx 2 -pady 2
frame .fft.f4.f41 -relief sunken -bd 3 -bg lightgrey
radiobutton .fft.f4.f41.rect -text  "Rectangular" -variable _fwin -value 1 -bg lightgrey -width 15 -anchor nw -state disabled
radiobutton .fft.f4.f41.hann -text  "Hann    " -variable _fwin -value 2 -bg lightgrey -width 15  -anchor nw -state disabled
radiobutton .fft.f4.f41.hamm -text  "Hamming  " -variable _fwin -value 3 -bg lightgrey -width 15  -anchor nw -state disabled
radiobutton .fft.f4.f41.black -text "Blackmann " -variable _fwin -value 4 -bg lightgrey -width 15  -anchor nw -state disabled
set _fwin 1
grid .fft.f4.f41.rect -row 1 -column 1 -padx 2 -pady 2 -sticky nw
grid .fft.f4.f41.hann -row 1 -column 2 -padx 2 -pady 2 -sticky nw
grid .fft.f4.f41.hamm -row 2 -column 1 -padx 2 -pady 2 -sticky nw
grid .fft.f4.f41.black -row 2 -column 2  -padx 2 -pady 2 -sticky nw
pack .fft.f4.l1 .fft.f4.f41 -side top -fill x -expand yes
pack .fft.f4 -side top -padx 2 -pady 2 -fill x -expand yes 
frame .fft.f5 -bg lightgrey -relief groove
button .fft.f5.ok -text "   OK   " -command lpcall2 -relief raised -bd 4 -bg lightgrey
bind .fft.f5.ok <Return> lpcall2 
button .fft.f5.cancel -text " CANCEL " -relief raised -bd 4 -bg lightgrey -command cancall2
bind .fft.f5.cancel <Return> cancall2 
pack .fft.f5.ok .fft.f5.cancel -side left -expand yes -fill both -padx 5 -pady 5
pack .fft.f5 -side top -expand yes -fill x -padx 2 -pady 2
label .fft.l3 -textvariable _enter3 -bg lightgrey -bd 3 -relief ridge
pack .fft.l3 -side top -expand yes -fill x -padx 2 -pady 2

bind .fft.f3.ecf <FocusIn> {
	global _enter3
	set _enter3 "Number less than 3.14 (PI) "
	update
}
bind .fft.f3.ecf1 <FocusIn> {
	global _enter3
	set _enter3 "Number less than 3.14 (PI) < cf high "
	update
}
bind .fft.f3.ecf2 <FocusIn> {
	global _enter3
	set _enter3 "Number less than 3.14 (PI) > cf low "
	update
}
bind .fft.f3.eirs <FocusIn> {
	global _enter3
	set _enter3 "Number must be power of 2 (8,16..)"
	update
}
bind .fft.f3.ems <FocusIn> {
	global _enter3
	set _enter3 "Number must be odd < isize"
	update
}
bind .fft.f3.eord <FocusIn> {
	global _enter3
	set _enter3 "Number must be < isize/2"
	update
}
bind .fft.f4.f41.rect <FocusIn> {
	global _enter3
	set _enter3 "select rectangular window function"
	update
}
bind .fft.f4.f41.hann <FocusIn> {
	global _enter3
	set _enter3 "select Hann window function"
	update
}
bind .fft.f4.f41.hamm <FocusIn> {
	global _enter3
	set _enter3 "select Hamming window function"
	update
}
bind .fft.f4.f41.black <FocusIn> {
	global _enter3
	set _enter3 "select Blackmann window function"
	update
}
bind .fft.f5.ok <FocusIn> {
	global _enter3
	set _enter3 "Press enter to process"
	update
} 
bind .fft.f5.cancel <FocusIn> {
	global _enter3
	set _enter3 "Press enter to cancel"
	update
}
bind .fft.f5.ok <Enter> {
	global _enter3 _enter3old
	set _enter3old $_enter3
	set _enter3 "press to process"
	update
} 
bind .fft.f5.ok <Leave> {
	global _enter3 _enter3old
	set _enter3 $_enter3old
	update
} 
bind .fft.f5.cancel <Enter> {
	global _enter3 _enter3old
	set _enter3old $_enter3
	set _enter3 "press to cancel"
	update
} 
bind .fft.f5.cancel <Leave> {
	global _enter3 _enter3old
	set _enter3 $_enter3old
	update
} 
bind .fft.f4.f41.rect <Enter> {
	global _enter3 _enter3old
	set _enter3old $_enter3
	set _enter3 "select rectangular window function"
	update
}
bind .fft.f4.f41.rect <Leave> {
	global _enter3 _enter3old
	set _enter3 $_enter3old
	update
}
bind .fft.f4.f41.hann <Enter> {
	global _enter3 _enter3old
	set _enter3old $_enter3
	set _enter3 "select Hann window function"
	update
}
bind .fft.f4.f41.hann <Leave> {
	global _enter3 _enter3old
	set _enter3 $_enter3old
	update
}
bind .fft.f4.f41.hamm <Enter> {
	global _enter3 _enter3old
	set _enter3old $_enter3
	set _enter3 "select Hamming window function"
	update
}
bind .fft.f4.f41.hamm <Leave> {
	global _enter3 _enter3old
	set _enter3 $_enter3old
	update
}
bind .fft.f4.f41.black <Enter> {
	global _enter3 _enter3old
	set _enter3old $_enter3
	set _enter3 "select Blackmann window function"
	update
}
bind .fft.f4.f41.black <Leave> {
	global _enter3 _enter3old
	set _enter3 $_enter3old
	update
}
proc ahelp {} {
	toplevel .help -width 300 -height 300 -background lightgrey
	set ah .help
	wm title $ah "About Project"
	wm geometry $ah +100+100
	message $ah.m -bg lightgrey -text "M.Tech project developed by \nT. Suresh Babu (98MCMI02) and \nP.Krishna Mohan (98MCMI14) in 1999" 
	message $ah.m1 -bg lightgrey -fg blue -text "Color operations \n developed by \n" 
	message $ah.m2 -bg lightgrey -fg blue -text "G.RajaRamesh(01mcmc17)\n Azeem MD(01mcmc04)\n"
	pack $ah.m
	pack $ah.m1
	pack $ah.m2
}
proc imgdelete {} {
	set file [fD . open]
	if { $file != "" } {
		delcall $file
	}
}
proc rm2 file {
	global obj _current _current1
	set f1 [file tail $file]
	if { ($_current1 == $file)||($_current1 == $f1) } { set _current1 "" ; set _current "" }
	set wi [unique get]
	for { set i 1 } { $i <= $wi } { incr i } {
		if {[winfo exists .t$i]} {
			set f [wm title .t$i]
			if { ($f == $file)||($f == $f1) } {
				set num [.menu.window index end]
				for { set j 2 } { $j <= $num } { incr j } {
					set f2 [.menu.window entrycget $j -label]
					if { ($file == $f2)||($f1 == $f2) } {
						.menu.window delete $j
					}
				}
				destroy .t$i
				set o [set obj(.t$i)]
				rename $o {}
			}
		}	
	}
	file delete $file
	pack forget .f3.l2
	pack forget .f3.f2
	pack forget .f3.l3
	pack forget .f3.f3
	pack forget .f3.l5
	pack forget .f3.f5
	pack forget .f3.l6
	pack forget .f3.f6
}
proc imgopen {} {
	global _current1 _current _status
	set file [fD . open]
	if { $file != "" } {
		raise .
		set _status "Please wait : image loading"
		update
		topopen $file
		set wi [unique get]
		set _current .t$wi
		set _current1 $file
		.menu.window add command -label "$file" -command  "rcall $file"
		gettype $file
		set _status "Every operation is performed on current image"
		update
	} 
}
proc imgsave {} {
	global _current obj _current1
	set fname [wm title $_current]
	set file [fD . save]
	if { $file != "" } {
		file rename $fname $file
		wm title $_current $file
		set _current1 $file
		set num [.menu.window index end]
		for { set i 2 } { $i <= $num } { incr i } {
			set f2 [.menu.window entrycget $i -label]
			if { $fname == $f2 } {
				.menu.window entryconfigure $i -label $file
				.menu.window entryconfigure $i -command "rcall $file"
			}
		}
	}
}
proc savecall2 file1 {
	set file [fD . save]
	if { $file != "" } {
		file rename $file1 $file
	} else {
		file delete $file1
	}
}
proc imgcopy {} {
	global _current obj
	set fname [wm title $_current]
	set file [fD . save]
	if { $file != "" } {
		file copy $fname $file
	}
}

proc iconcall {} {
	set wi [unique get]
	for {set i 1} {$i <= $wi} {incr i} {
		if {[winfo exists .t$i]} {
			wm iconify .t$i
		}
	}
}


proc singleopr opr {
	global _current obj _status _i _j _k _model
	if { $_current == "" } {
		error "select a file "
	}
	set flags [ expr $_k * 4 + $_j * 2 + $_i ]
	set _status "Wait process running"
	raise .
	update
	set objname [set obj($_current)]
	set j [catch {$objname $opr -flags $flags -model $_model} fname]
	if { ( $j == 0 ) && ( $fname != "") } {
		topopen $fname
		.menu.window add command -label "$fname" -command "rcall $fname"
	} 
	set _status "Every operation is performed on current image"
	update
	if { $j==1 } {
		error $fname
	}
}


proc cancall9 {} {
	global _opr
	pack forget .color
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -anchor nw -expand yes -fill y
	.color.f1.ered configure -state disabled -bg lightgrey
	.color.f1.erbw configure  -state disabled -bg lightgrey
	.color.f1.egreen configure  -state disabled -bg lightgrey
	.color.f1.egbw configure  -state disabled -bg lightgrey
	.color.f1.eblue configure  -state disabled -bg lightgrey
	.color.f1.ebbw configure  -state disabled -bg lightgrey
	.color.f1.enm configure  -state disabled -bg lightgrey
	.color.f1.enmbw configure  -state disabled -bg lightgrey
	.color.f1.eorder configure  -state disabled -bg lightgrey
	.color.f1.ebox configure  -state disabled -bg lightgrey
	.color.f1.elevels configure -state disabled -bg lightgrey
	.color.f1.ecolors configure -state disabled -bg lightgrey
	.color.f1.eper configure -state disabled -bg lightgrey
	.color.f1.epoles configure -state disabled -bg lightgrey
	.color.t1 configure  -state disabled -bg lightgrey
	set _opr ""
	update
}

proc coloropr opr { 
	global _opr _operation
	raise .
	
	update idletasks
	switch $opr {
		idealpass - 
		idealreject {
			.color.f1.ered configure -state normal -bg white
			.color.f1.erbw configure -state normal -bg white
			.color.f1.egreen configure -state normal -bg white
			.color.f1.egbw configure -state normal -bg white
			.color.f1.eblue configure -state normal -bg white
			.color.f1.ebbw configure -state normal -bg white
			focus .color.f1.ered
			update idletasks
		}
		butterworthpass -
		butterworthreject {
			.color.f1.ered configure -state normal -bg white
			.color.f1.erbw configure -state normal -bg white
			.color.f1.egreen configure -state normal -bg white
			.color.f1.egbw configure -state normal -bg white
			.color.f1.eblue configure -state normal -bg white
			.color.f1.ebbw configure -state normal -bg white
			.color.f1.eorder configure -state normal -bg white
			focus .color.f1.ered
			update idletasks

		}
		hsiidealpass -
  		hsiidealreject {
			.color.f1.egreen configure -state normal -bg white
			.color.f1.egbw configure -state normal -bg white
			focus .color.f1.egreen
			update idletasks
		}
		hsibutterworthpass -
		hsibutterworthreject {
			.color.f1.egreen configure -state normal -bg white
			.color.f1.egbw configure -state normal -bg white
			.color.f1.eorder configure -state normal -bg white
			focus .color.f1.egreen
			update idletasks
		}
		xyzfilter {
		        .color.f1.enm configure -state normal -bg white
			.color.f1.enmbw configure -state normal -bg white
			.color.f1.eorder configure -state normal -bg white
			focus .color.f1.egreen
			update idletasks   
		}
		medcut {
		        .color.f1.ebox configure -state normal -bg white
			focus .color.f1.ebox
			update idletasks
		}
		octree {
	               .color.f1.elevels configure -state normal -bg white
		       .color.f1.ecolors configure -state normal -bg white
		       focus .color.f1.elevels
		       update idletasks
		}
		huepolarise {
			.color.f1.epoles configure -state normal -bg white
			.color.f1.eper configure -state normal -bg white
			.color.t1 configure -state normal -bg white
			focus .color.f1.epoles
			update idletasks
		}
		satuvariation {
			.color.f1.eper configure -state normal -bg white
			focus .color.f1.eper
			update idletasks
		}
	}
	pack forget .ft.toolbar
	pack forget .newimg
	pack forget .f3
	pack forget .edit
	pack forget .prefer
	pack forget .point
	pack forget .fft
	pack forget .filter
	pack .color -side top
	
	set _operation $opr
	update idletasks
	update
	set _opr $opr
}

proc colorcall {} {
	global _current obj _opr _model _ival _ibw _jval _jbw _kval _kbw _nm _nmbw _ord _box _levels _color _per _poles _i _j _k _values
	if { $_current == "" } { 
		error "select a image"
	}
	set _status "Wait process running"
	update idletasks
	set flags [ expr $_k * 4 + $_j * 2 + $_i ]
	set objname [set obj($_current)]
	switch $_opr {
		idealpass - 
		idealreject {
			set s "$objname $_opr -point $_ival $_jval $_kval -bw $_ibw $_jbw $_kbw -model $_model"
		}
		butterwothpass -
		butterworthreject {
			set s "$objname $_opr -point $_ival $_jval $_kval -bw $_ibw $_jbw $_kbw -order $_ord -model $_model"

		}
		hsiidealpass -
  		hsiidealreject {
			set s "$objname $_opr -hue $_jval -bw $_jbw -model $_model"
		}
		hsibutterworthpass -
		hsibutterworthreject {
			set s "$objname $_opr -hue $_jval -bw $_jbw -model $_model -order $_ord"
		}
		xyzfilter {
		            set s "$objname $_opr -nm $_nm -bw $_nmbw -order $_ord"
		}
		medcut {
		        set s "$objname $_opr $_box"
		}
		octree {
	                set s "$objname $_opr $_levels $_color"
		}
		huepolarise {
			set _values [.color.t1 get 1.0 end]
			if {[llength $_values] != $_poles} {
				error "Insufficient number of  elements"
			}
			set s "$objname $_opr -per $_per -n $_poles -values [lrange $_values 0 end]"
		}
		satuvariation {
			set s "$objname $_opr -per $_per"
		}
		
	}
	set j [catch { eval $s } fname ]
	if { $j==0 } {
		topopen $fname
		.menu.window add command -label "$fname" -command "rcall $fname"
	}
	pack forget .color 
	set _opr ""
	set _status "Every operation is performed on current image"
	cancall9
	if { $j == 1 } {
		error $fname
	}
}




proc cancall1 {} {
	global _opr
	pack forget .filter
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -anchor nw -expand yes -fill y
	.filter.f1.erows configure -state disabled -bg lightgrey
	.filter.f1.ecols configure  -state disabled -bg lightgrey
	.filter.f1.eorgx configure  -state disabled -bg lightgrey
	.filter.f1.eorgy configure  -state disabled -bg lightgrey
	.filter.f1.eamp configure  -state disabled -bg lightgrey
	.filter.f1.esig configure  -state disabled -bg lightgrey
	.filter.f1.efac configure  -state disabled -bg lightgrey
	.filter.f1.estddev configure  -state disabled -bg lightgrey
	.filter.t1 configure  -state disabled -bg lightgrey
	.filter.f1.elow configure  -state disabled -bg lightgrey
	.filter.f1.ehigh configure  -state disabled -bg lightgrey
	set _opr ""
	update
}

proc lpcall opr {
	global _opr _operation
	raise .
	.filter.f1.eorgx configure -state normal -bg white
	.filter.f1.eorgy configure -state normal -bg white
	.filter.f1.erows configure -state normal -bg white
	.filter.f1.ecols configure -state normal -bg white
	.filter.t1 configure -state normal -bg white
	focus .filter.f1.erows 
	update idletasks 
	switch $opr {
		bidilate { 
			set _operation { Binary Dilation } 
		}
		bierode {
			set _operation { Binary Erosion }
		}
		biopen {
			set _operation { Binary Opening }
		}
		biclose {
			set _operation { Binary Closing }
		}
		dilate {
			set _operation { Greylevel Dilation }
		}
		erode {
			set _operation { Greylevel Erosion }
		}
		close {
			set _operation { Greylevel Closing }
		}
		open {
			set _operation { Greylevel Opening }
		}
	}
	pack forget .f3
	pack forget .newimg
	pack forget .edit
	pack forget .ft.toolbar
	pack forget .fft
	pack forget .point
	pack forget .prefer
	pack forget .color
	pack .filter -side top 
	update
	set _opr $opr
}

proc filcall opr {
	global _opr _operation
	raise .
	switch $opr {
		mlowpass -
		mhighpass {
			.filter.f1.eorgx configure -state normal -bg white
			.filter.f1.eorgy configure -state normal -bg white
			.filter.f1.erows configure -state normal -bg white
			.filter.f1.ecols configure -state normal -bg white
			focus .filter.f1.erows
			update idletasks 
		}
		highboost {
			.filter.f1.eamp configure -state normal -bg white
			focus .filter.f1.eamp
			update idletasks 
		}
		gaussian {
			.filter.f1.esig configure -state normal -bg white
			focus .filter.f1.esig
			update idletasks 
		}
		canny {
			.filter.f1.estddev configure -state normal -bg white
			.filter.f1.elow configure -state normal -bg white
			.filter.f1.ehigh configure -state normal -bg white
			focus .filter.f1.estddev
			update idletasks 
		}
		applymedian {
			.filter.f1.eorgx configure -state normal -bg white
			.filter.f1.eorgy configure -state normal -bg white
			.filter.f1.erows configure -state normal -bg white
			.filter.f1.ecols configure -state normal -bg white
			focus .filter.f1.erows
			update idletasks 
		}
		applymask {
			.filter.f1.efac configure -state normal -bg white
			.filter.f1.eorgx configure -state normal -bg white
			.filter.f1.eorgy configure -state normal -bg white
			.filter.f1.erows configure -state normal -bg white
			.filter.f1.ecols configure -state normal -bg white
			.filter.t1 configure -state normal -bg white
			focus .filter.f1.erows
			update idletasks 
		}
	}
	set _operation $opr
	pack forget .ft.toolbar
	pack forget .newimg
	pack forget .f3
	pack forget .edit
	pack forget .prefer
	pack forget .point
	pack forget .fft
	pack forget .color
	pack .filter 
	update
	set _opr $opr
}

proc lpcall1 {} {
	global _current obj _sig _stddev _low _high _amp _rows _cols _orgx _orgy _values _opr _status _fac _model _i _j _k
	if { $_current == "" } { 
		error "select a image"
	}
	set _status "Wait process running"
	set flags [ expr $_k * 4 + $_j * 2 + $_i ]
	update idletasks
	set objname [set obj($_current)]
	switch $_opr {
		dilate -
		bidilate -
		erode -
		bierode -
		open -
		biopen -
		close -
		biclose {
			set _values [.filter.t1 get 1.0 end]
			set total [expr $_rows*$_cols]
			if {[llength $_values] != $total} {
				error "Insufficient number of Mask elements"
			}
			set s "$objname $_opr -mask [set _rows]x[set _cols] [set _orgx]x[set _orgy] [lrange $_values 0 end]"
		}
		highboost {
			set s "$objname highboost -amplification $_amp -flags $flags -model $_model"
		}
		gaussian {
			set s "$objname gaussian -sigma $_sig -flags $flags -model $_model"
		}
		canny {
			set s "$objname canny -stddev $_stddev -thresholds $_low $_high -flags $flags -model $_model"
		}
		mlowpass -
		mhighpass -
		applymedian {
			set s "$objname $_opr -mask [set _rows]x[set _cols] [set _orgx]x[set _orgy] -flags $flags -model $_model"
		}
		applymask {
			set _values [.filter.t1 get 1.0 end]
			set total [expr $_rows*$_cols]
			if {[llength $_values] != $total} {
				error "Insufficient number of Mask elements"
			}
			set s "$objname $_opr -mask [set _rows]x[set _cols] [set _orgx]x[set _orgy] [lrange $_values 0 end] -factor $_fac -flags $flags -model $_model"
		}
	}
	set j [catch { eval $s } fname ]
	if { $j==0 } {
		topopen $fname
		.menu.window add command -label "$fname" -command "rcall $fname"
	}
	pack forget .filter 
	set _opr ""
	set _status "Every operation is performed on current image"
	cancall1
	if { $j==1 } {
		error $fname
	}
}
proc cancall3 {} {
	.point.f1.ellimit configure -state disabled -bg lightgrey
	.point.f1.eulimit configure  -state disabled -bg lightgrey
	.point.f1.eiter configure  -state disabled -bg lightgrey
	.point.f1.ebps configure  -state disabled -bg lightgrey
	.point.f2.ethr configure  -state disabled -bg lightgrey
	.point.f2.gray configure  -state disabled -bg lightgrey
	.point.f2.per configure  -state disabled -bg lightgrey
	.point.f3.efile configure  -state disabled -bg lightgrey
	.point.f3.browse configure  -state disabled -bg lightgrey
	.point.f3.avg configure  -state disabled -bg lightgrey
	.point.f3.max configure  -state disabled -bg lightgrey
	pack forget .point
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -anchor nw -expand yes -fill y
}

proc pointcall opr {
	global _operation _opr percen _super typ
	set _operation $opr
	update
	if { $typ == "P3" || $typ == "P6" && $opr == "range" } {
		set _opr "idealpass"
		coloropr idealpass
	} else {
	switch $opr {
		stretch {
			.point.f1.ellimit configure -state normal -bg white
			.point.f1.eulimit configure -state normal -bg white
			focus .point.f1.ellimit
			set _opr $opr
			update idletasks 
		}
		range {
			.point.f1.ellimit configure -state normal -bg white
			.point.f1.eulimit configure -state normal -bg white
			focus .point.f1.ellimit
			set _opr $opr
			update idletasks 
		}
		istretch {
			.point.f1.eiter configure -state normal -bg white
			focus .point.f1.eiter
			set _opr $opr
			update idletasks 
		}
		bpslice {
			.point.f1.ebps configure -state normal -bg white
			focus .point.f1.ebps
			set _opr $opr
			update idletasks 
		}
		threshold {
			.point.f2.ethr configure -state normal -bg white
			if { $typ == "P3" || $typ == "P6" } { 
				.point.f2.ethrg configure -state normal -bg white
				.point.f2.ethrb configure -state normal -bg white
			}
			.point.f2.gray configure -state normal 
			.point.f2.per configure -state normal 
			focus .point.f2.ethr
			update idletasks 
			set _opr threshold
		}
		difference {
			.point.f3.efile configure -state normal -bg white
			.point.f3.browse configure -state normal
			focus .point.f3.efile
			update idletasks 
			set _opr $opr
		}
		addition {
			.point.f3.efile configure -state normal -bg white
			.point.f3.browse configure -state normal 
			.point.f3.avg configure -state normal 
			.point.f3.max configure -state normal 
			focus .point.f3.efile
			update idletasks 
			set _opr addition
		}
		
	}
	
	pack forget .fft
	pack forget .newimg
	pack forget .f3
	pack forget .filter
	pack forget .ft.toolbar
	pack forget .prefer
	pack forget .edit
	pack forget .color
	pack .point -side top
	raise . 
	update idletasks
	}		
}

proc lpcall3 {} {
	global obj _current _opr _llimit _ulimit _iter _bpval _thr _thrg _thrb percen _sfile _super _status1 _status _model _i _j _k
	if { $_current == "" } {
		error "select a file "
	}
	set _status "Wait process running"
	update idletasks
	set objname [set obj($_current)]
	set flags [ expr $_k * 4 + $_j * 2 + $_i ]
	switch $_opr {
		stretch {
			set j [catch {$objname $_opr $_llimit $_ulimit -model $_model -flags $flags} fname]
		}
		range {
			set j [catch {$objname $_opr $_llimit $_ulimit} fname]
		}
		istretch {
			set j [catch {$objname $_opr $_iter} fname]
		}
		bpslice {
			set j [catch {$objname $_opr $_bpval -model $_model -flags $flags} fname]
		}
		difference {
			set i [pimage $_sfile]
			set j [catch {$objname $_opr $i} fname]
			rename $i {}
		}
		addition {
			set i [pimage $_sfile]
			if { $_super == 0 } {
				set j [catch {$objname superavg $i} fname]
			} else {
				set j [catch {$objname supermax $i} fname]
			}	
			rename $i {}
		}
		threshold {
			if { $percen == 0 } {
				set j [catch {$objname gthreshold  $_thr $_thrg $_thrb -model $_model -flags $flags} fname]
			} else {
				set j [catch {$objname pthreshold  $_thr $_thrg $_thrb -model $_model -flags $flags} fname]
			}
		}
	}	
	cancall3
	if { ( $j == 0 ) && ( $fname != "") } {
		topopen $fname
		.menu.window add command -label "$fname" -command "rcall $fname"
		
	}
	set _opr ""
	set _status "Every operation is performed on current image"
	update idletasks
	if { $j==1 } {
		error $fname
	}
}

proc filtercall opr {
	global _user
	if { $_user == 0 } {
		singleopr $opr
	} else {
		filcall $opr
	}
}

proc morphcall opr {
	global _user _type
	if { $_user == 0 } {
		switch $_type {
			0 { singleopr bi$opr}
			1 { singleopr $opr}
		}
	} else {
		switch $_type {
			0 { lpcall bi$opr }
			1 { lpcall $opr }
		}
	}
	
}

proc cancall2 {} {
	global _opr1 _opr2
	set _opr1 ""
	set _opr2 ""
	pack forget .fft
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -anchor nw -expand yes -fill y
	.fft.f3.ecf configure -bg lightgrey -state disabled
	.fft.f3.ecf1 configure -bg lightgrey -state disabled 
	.fft.f3.ecf2 configure  -bg lightgrey -state disabled
	.fft.f3.eirs configure  -bg lightgrey -state disabled
	.fft.f3.ems configure  -bg lightgrey -state disabled
	.fft.f3.eord configure  -bg lightgrey -state disabled
	.fft.f4.f41.rect configure  -bg lightgrey -state disabled
	.fft.f4.f41.hann configure  -bg lightgrey -state disabled
	.fft.f4.f41.hamm configure  -bg lightgrey -state disabled
	.fft.f4.f41.black configure  -bg lightgrey -state disabled
	update idletasks
}

proc fftcall opr {
	global _filter _filclas _filtype _opr1 _opr2 _user
	switch $_filter {
		0 {
			set _opr1 "fft"
			set _filclas "FFT Filter"
		}
		1 {
			set _opr1 "fir"
			set _filclas "FIR Filter"
		}
		2 {
			set _opr1 "iir"
			set _filclas "IIR Filter"
		}
	}
	
	set _opr2 $opr
	set _filtype $opr
	
	if { $_user == 0 } {
		dbopr $_opr1 $_opr2
	} else {
		switch $opr {
			flowpass -
			fhighpass -
			fbwhighpass -
			fbwlowpass {
				.fft.f3.ecf configure -bg white -state normal
				focus .fft.f3.ecf
				update idletasks 
				if { $_filter == 1 } {
					.fft.f3.ems configure -bg white -state normal
					.fft.f3.eirs configure -bg white -state normal
					.fft.f4.f41.rect configure -state normal
					.fft.f4.f41.hann configure -state normal
					.fft.f4.f41.hamm configure -state normal
					.fft.f4.f41.black configure -state normal
				}
				if { $_filter == 2 } {
					.fft.f3.eord configure -bg white -state normal
					.fft.f3.eirs configure -bg white -state normal
					.fft.f4.f41.rect configure -state normal
					.fft.f4.f41.hann configure -state normal
					.fft.f4.f41.hamm configure -state normal
					.fft.f4.f41.black configure -state normal
				}
			}
			fbandpass -
			fbandreject {
				.fft.f3.ecf1 configure -bg white -state normal	
				.fft.f3.ecf2 configure -bg white -state normal	
				focus .fft.f3.ecf1
				update idletasks 
				if { $_filter == 1 } {
					.fft.f3.ems configure -bg white -state normal
					.fft.f3.eirs configure -bg white -state normal
					.fft.f4.f41.rect configure -state normal
					.fft.f4.f41.hann configure -state normal
					.fft.f4.f41.hamm configure -state normal
					.fft.f4.f41.black configure -state normal
				}
				if { $_filter == 2 } {
					.fft.f3.eord configure -bg white -state normal
					.fft.f3.eirs configure -bg white -state normal
					.fft.f4.f41.rect configure -state normal
					.fft.f4.f41.hann configure -state normal
					.fft.f4.f41.hamm configure -state normal
					.fft.f4.f41.black configure -state normal
				}
			}
		}
		
		pack forget .filter
		pack forget .newimg
		pack forget .f3
		pack forget .edit
		pack forget .point
		pack forget .ft.toolbar
		pack forget .prefer
		pack forget .color
		pack .fft -side top
		raise .
		update idletasks
	}
}

proc dbopr {opr1 opr2} {
	global _current obj _status
	if { $_current == "" } {
		error "select a file "
	}
	set _status "Wait process running"
	raise .
	update idletasks
	set objname [set obj($_current)]
	set j [catch {$objname $opr2 -type $opr1} fname]
	if { ( $j == 0 ) && ( $fname != "") } {
		topopen  $fname
		.menu.window add command -label "$fname" -command "rcall $fname"
		
	}
	set _status "Every operation is performed on current image"
	update idletasks
	if { $j==1 } {
		error $fname
	}
}

proc lpcall2 {} {
	global _current obj _status _opr1 _opr2 _cf _cf1 _cf2 _irs _ms _ord _fwin _filter
	if { $_current == "" } {
		error "select a file "
	}
	set _status "Wait process running"
	raise .
	update idletasks
	set objname [set obj($_current)]
	switch $_opr2 {
		flowpass -
		fhighpass -
		fbwlowpass -
		fbwhighpass {
			switch $_filter {
				0 {		
					set s "$objname $_opr2 -type $_opr1 -values $_cf" 
				}
				1 {
					set s "$objname $_opr2 -type $_opr1 -values $_irs $_ms $_cf $_fwin"
				}
				2 {
					set s "$objname $_opr2 -type $_opr1 -values $_irs $_ord $_cf $_fwin"
				}
			}
		}	
		fbandpass -
		fbandreject {
			switch $_filter {
				0 {		
					set s "$objname $_opr2 -type $_opr1 -values $_cf1 $_cf2" 
				}
				1 {
					set s "$objname $_opr2 -type $_opr1 -values $_irs $_ms $_cf1 $_cf2 $_fwin"
				}
				2 {
					set s "$objname $_opr2 -type $_opr1 -values $_irs $_ord $_cf1 $_cf2 $_fwin"
				}
			}
		}	
	}
	
	set j [catch { eval $s } fname]
	if { ( $j == 0 ) && ( $fname != "") } {
		topopen $fname
		.menu.window add command -label "$fname" -command "rcall $fname"
		
	}
	cancall2
	set _status "Every operation is performed on current image"
	update idletasks
	if { $j==1 } {
		error $fname
	}
}


proc rcall filename {
	global _current _current1
	set wi [unique get]
	for { set i 1 } { $i <= $wi } { incr i } {
		if {[winfo exists .t$i]} {
			set f [wm title .t$i]
			if { $f == $filename } {
				wm deiconify .t$i
				raise .t$i
				set _current .t$i
				set _current1 $filename
			}
		}
	}
	gettype $filename		
}

proc gettype filename {
	global typ w 
	set fid [ open $filename r ]
	set typ [ read $fid 2 ]
	
	if { $typ == "P3"  ||  $typ == "P6" } { 
		pack forget .f3.l2
		pack forget .f3.f2
		pack forget .f3.l3
		pack forget .f3.f3
		pack .f3.l5
		pack .f3.f5
		pack .f3.l6
		pack .f3.f6
		set men $w.menu
		$men entryconfigure 6 -state disabled
		$men entryconfigure 7 -state disabled
		$men entryconfigure 8 -state disabled
		
		$men entryconfigure 9 -state normal
		$men entryconfigure 10 -state normal
		$men entryconfigure 11 -state normal
	} else {
		pack forget .f3.l5
		pack forget .f3.f5
		pack forget .f3.l6
		pack forget .f3.f6
		pack .f3.l2
		pack .f3.f2
		pack .f3.l3
		pack .f3.f3
		set men $w.menu
		$men entryconfigure 6 -state normal
		$men entryconfigure 7 -state normal
		$men entryconfigure 8 -state normal
		
		$men entryconfigure 9 -state disabled
		$men entryconfigure 10 -state disabled
		$men entryconfigure 11 -state disabled		
	}
	close $fid
	update idletasks 
}

proc dispmodel {} {
	global _model 
	if { $_model == "RGB" } {
		.f3.f6.r1 configure -text "RED"
		.f3.f6.r2 configure -text "GREEN"
		.f3.f6.r3 configure -text "BLUE"
		.color.f1.lred configure -text "RED"
		.color.f1.lrbw configure -text "R Bandwidth"
		.color.f1.lgreen configure -text "GREEN"
		.color.f1.lgbw configure -text "G Bandwidth"
		.color.f1.lblue configure -text "BLUE"
		.color.f1.lbbw configure -text "B Bandwidth"
	} elseif { $_model == "HSV" } {
		.f3.f6.r1 configure -text "VALUE"
		.f3.f6.r2 configure -text "HUE"
		.f3.f6.r3 configure -text "SATURATION"
		.color.f1.lred configure -text "VALUE"
		.color.f1.lrbw configure -text "V Bandwidth"
		.color.f1.lgreen configure -text "HUE"
		.color.f1.lgbw configure -text "H Bandwidth"
		.color.f1.lblue configure -text "SATU"
		.color.f1.lbbw configure -text "S Bandwidth"
	} elseif { $_model == "XYZ" } {
		.f3.f6.r1 configure -text "Y"
		.f3.f6.r2 configure -text "X"
		.f3.f6.r3 configure -text "Z"
		.color.f1.lred configure -text "Y"
		.color.f1.lrbw configure -text "Y Bandwidth"
		.color.f1.lgreen configure -text "X"
		.color.f1.lgbw configure -text "X Bandwidth"
		.color.f1.lblue configure -text "Z"
		.color.f1.lbbw configure -text "Z Bandwidth"
	} elseif { $_model == "YIQ" } {
		.f3.f6.r1 configure -text "Y"
		.f3.f6.r2 configure -text "I"
		.f3.f6.r3 configure -text "Q"
		.color.f1.lred configure -text "Y"
		.color.f1.lrbw configure -text "Y Bandwidth"
		.color.f1.lgreen configure -text "I"
		.color.f1.lgbw configure -text "I Bandwidth"
		.color.f1.lblue configure -text "Q"
		.color.f1.lbbw configure -text "Q Bandwidth"
	} 
	update idletasks
}		

proc imgpaste {} {
	global _current _px _py _eopr
	global _px$_current _py$_current
	if { $_current == "" } {
		error "select a file"
	}
	set _px [set _px$_current]
	set _py [set _py$_current]
	set _eopr paste
	.edit.f2.epx configure -state normal -bg white
	.edit.f2.epy configure -state normal -bg white
	.edit.f2.efile configure -state normal -bg white
	.edit.f2.browse configure -state normal 
	focus .edit.f2.epx
	update idletasks
	pack forget .filter
	pack forget .newimg
	pack forget .fft
	pack forget .point
	pack forget .ft.toolbar
	pack forget .f3
	pack forget .prefer
	pack forget .color
	raise .
	pack .edit -side top
	update
}

proc imgselect {} {
	global _current obj _tx _ty _bx _by _eopr
	global _tx$_current _ty$_current _bx$_current _by$_current
	if { $_current == "" } {
		error "select a file"
	}
	set x1 [set _tx$_current]
	set y1 [set _ty$_current]
	set x2 [set _bx$_current]
	set y2 [set _by$_current]
	if { $x1 > $x2 } {
		set _tx $x2
		set _bx $x1
	} else {
		set _tx $x1
		set _bx $x2
	}
	if { $y1 > $y2 } {
		set _ty $y2
		set _by $y1
	} else {
		set _ty $y1
		set _by $y2
	}
	.edit.f1.etx configure -state normal -bg white
	.edit.f1.ety configure -state normal -bg white
	.edit.f1.ebx configure -state normal -bg white
	.edit.f1.eby configure -state normal -bg white
	focus .edit.f1.etx
	update idletasks
	set _eopr select
	pack forget .filter
	pack forget .newimg
	pack forget .fft
	pack forget .point
	pack forget .ft.toolbar
	pack forget .f3
	pack forget .prefer
	pack forget .color
	raise .
	pack .edit -side top
	update
}

proc cancall4 {} {
	global _eopr
	set _eopr null
	.edit.f1.etx configure -state disabled -bg lightgrey
	.edit.f1.ety configure -state disabled -bg lightgrey
	.edit.f1.ebx configure -state disabled -bg lightgrey
	.edit.f1.eby configure -state disabled -bg lightgrey
	.edit.f2.epx configure -state disabled -bg lightgrey
	.edit.f2.epy configure -state disabled -bg lightgrey
	.edit.f2.efile configure -state disabled -bg lightgrey
	.edit.f2.browse configure -state disabled
	pack forget .edit
	pack .ft.toolbar -side top -expand yes -fill x -anchor nw
	pack .f3 -side left -anchor nw -expand yes -fill y
}
proc lpcall4 {} {
	global _current obj _tx _ty _bx _by _eopr _pfile _px _py _status
	global _tx$_current _ty$_current _bx$_current _by$_current
	if { $_current == ""} {
		error "select a file"
		cancall4
	}
	set img [set obj($_current)]
	set _status "Wait process running"
	update
	switch $_eopr {
		select {
			set j [catch {$img select $_ty $_tx $_by $_bx} fname]
			if { $j==0 } {
				topopen  $fname
				.menu.window add command -label "$fname" -command "rcall $fname"
			}
			set _bx$_current 0
			set _by$_current 0
			set _tx$_current 0
			set _ty$_current 0
			set _tx 0
			set _ty 0
			set _bx 0
			set _by 0
			$_current.f1.f11.f111.c delete recta
		}
		paste {
			if { $_pfile == ""} {
				error "select a file"
			}
			set j [ catch { pimage $_pfile -objname sel } fname ]
			if { $j == 0 } { 
				set j [ catch { $img paste sel $_py $_px } fname ]
				if { $j == 0 } { 
					topopen $fname
					.menu.window add command -label "$fname" -command "rcall $fname"
				}
				rename sel {}
			}
			set _px$_current 0
			set _py$_current 0
			set _px 0
			set _py 0
		}
		
	}
	set _status "Every operation is performed on current image"
	update idletasks
	cancall4
	if { $j == 1 } {
		error $fname
	}
}

