option add *Balloonhelp*background white widgetDefault
option add *Balloonhelp*foreground black widgetDefault
option add *Balloonhelp.info.wraplength 3i widgetDefault
option add *Balloonhelp.info.justify left widgetDefault
toplevel .balloonhelp -class Balloonhelp -bg black -bd 1 -relief flat
label .balloonhelp.info 
pack .balloonhelp.info -side left -fill y
wm overrideredirect .balloonhelp 1
wm withdraw .balloonhelp 
#set bhinfo(active) 1
global _show
set _show 1
proc balloonhelp_for {win mesg} {
	global bhinfo
	set bhinfo($win) $mesg
	bind $win <Enter> {
		balloonhelp_pending %W
	}
	bind $win <Leave> {
		balloonhelp_cancel
	}
}
proc balloonhelp_pending win {
	global bhinfo
	balloonhelp_cancel
	set bhinfo(pending) [after 1000 [list balloonhelp_show $win]]
}
proc balloonhelp_cancel {} {
	global bhinfo
	if { [info exists bhinfo(pending)] } {
		after cancel $bhinfo(pending)
		unset bhinfo(pending)
	}
	wm withdraw .balloonhelp
}
proc balloonhelp_show win {
	global bhinfo _show
	if { $_show } {
		.balloonhelp.info configure -text $bhinfo($win)
		set x [expr [winfo rootx $win]+10]
		set y [expr [winfo rooty $win]+[winfo height $win]]
		wm geometry .balloonhelp +$x+$y
		wm deiconify .balloonhelp
		raise .balloonhelp
	}
	unset bhinfo(pending)
}

