#include <tcl.h>
#include <tk.h>
#ifndef IPTKINTERP
#define IPTKINTERP "/usr/local/packages/IPTK/prj11.tcl"
#endif

extern int PimageCmd(ClientData clientData, Tcl_Interp *interp, int argc,
			char *argv[]);
extern int SetmemCmd(ClientData clientData, Tcl_Interp *interp, int argc,
			char *argv[]);
extern int SettexCmd(ClientData clientData, Tcl_Interp *interp, int argc,
			char *argv[]);
extern int CounterCmd(ClientData clientData, Tcl_Interp *interp, int argc,
			char *argv[]);
extern int NewimgCmd(ClientData clientData, Tcl_Interp *interp, int argc,
			char *argv[]);

int Pimg_Init(Tcl_Interp *interp){
	char c[]="rename exit exit.old";
	Tcl_CreateCommand(interp, "pimage", PimageCmd, (ClientData) NULL,
				(Tcl_CmdDeleteProc *) NULL);
	Tcl_CreateCommand(interp, "setmem", SetmemCmd, (ClientData) NULL,
				(Tcl_CmdDeleteProc *) NULL);
	Tcl_CreateCommand(interp, "settex", SettexCmd, (ClientData) NULL,
				(Tcl_CmdDeleteProc *) NULL);
	Tcl_CreateCommand(interp, "unique", CounterCmd, (ClientData) NULL,
				(Tcl_CmdDeleteProc *) NULL);
	Tcl_CreateCommand(interp, "newimg", NewimgCmd, (ClientData) NULL,
				(Tcl_CmdDeleteProc *) NULL);
	Tcl_Eval(interp,c);
	return Tcl_EvalFile(interp,IPTKINTERP);
	}

